-- @release $Id: Options.lua 1 2016-08-12 21:19:41Z reighnman $

if not ShockAndAwe then return end

local L = LibStub("AceLocale-3.0"):GetLocale("ShockAndAwe")
local media = LibStub:GetLibrary("LibSharedMedia-3.0");
if not C then
  ShockAndAwe:SetConstants()
end
local _, _, _, clientVersion = GetBuildInfo()

ShockAndAwe.emptyOptions = { "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
ShockAndAwe.enhancementOptions = { "fs_boss", "bf2", "fb_nfb", "ft_nft", "ws", "asc_boss", "foa_nfoa", "dw", "cl_aoe", "ws", "ss", "fb_hs", "ft_dur", "lb_oc60", "ll_hh", "es", "cl_apl", "sun", "ll_90", "rb", "ft", "bf", "none", "none", "none", "none", "none", "none", "none", "none" }
ShockAndAwe.restorationOptions = { "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }
ShockAndAwe.elementalOptions = { "asc_boss", "fl_sh", "fl_sh_asc", "ea_sh92", "lav_apl", "el_bl", "ea_sh86", "lb", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none", "none" }

ShockAndAwe.fonteffects = {
  ["none"] = L["None"],
  ["OUTLINE"] = L["OUTLINE"],
  ["THICKOUTLINE"] = L["THICKOUTLINE"],
  ["MONOCHROME"] = L["MONOCHROME"],
}

-------------------
-- Config details
-------------------
function ShockAndAwe:SetDefaultOptions()
  ShockAndAwe.defaults = {
    char = {
      disabled = false,
      specchangewarning = true,
      message = "Welcome Home!",
      movingframes = false,
      showicons = true,
      relativeTo = "UIParent",
      relativePoint = "CENTER",
      point = "CENTER",
      texture = "Blizzard",
      barfont = "Friz Quadrata TT",
      barfontsize = 12,
      barfonteffect = "none",
      msgfont = "Friz Quadrata TT",
      msgfontsize = 24,
      msgfonteffect = "none",
      border = "None",
      barborder = "Blizzard Tooltip",
      tfb5flash = true,
      tfb4sound = "Sound\\Spells\\ShootWandLaunchLightning.wav",
      tfb4soundname = "SAA Maelstrom 1",
      tfb5sound = "Sound\\SPELLS\\SlowTaget.ogg",
      tfb5soundname = "SAA Maelstrom 2",
      shieldsound = "Sound\\Doodad\\BellowIn.wav",
      shieldsoundname = "SAA Shield 1",
      weaponsound = "Sound\\Doodad\\BellowIn.wav",
      weaponsoundname = "SAA Shield 1",
      framestratalevel = "LOW",
      xOffset = 0,
      yOffset = -220,
      fWidth = 300,
      fHeight = 175,
      resetOn = true,
      scale = 1,
      ShockPercent = .6,
      ShearPercent = .6,
      shockshow = true,
      shearshow = false,
      ssshow = true,
      firetotemshow = true,
      wfshow = true,
      fsdotshow = true,
      gcdshow = true,
      gcdfullwidth = false,
      fnshow = true,
      fsshow = true,
      petshow = false,
      disablebars = false,
      maelstromTalents = 0,
      feralSpiritTalented = false,
      tfb4soundplay = true,
      tfb5soundplay = true,
      tfb5repeat = 3,
      tfbflash = true,
      shieldshow = true,
      tfbshow = true,
      tfbstacks = 0,
      arena = false,
      barstext = true,
      SSlen = 8,
      maxLen = 10,

      --ShockAndAwe
      maelstromshow = true,
      hsshow = true,
      maelstromThreshold = 90,
      csshow = true,
      bcshow = true,
      bbshow = true,
      ipshow = true,
      sblshow = true,
      swshow = true,
      avashow = true,
      drshow = true,
      demoshoutshow = true,
      laststandshow = true,
      commandingshoutshow = true,
      CSLen = 8,
      BBLen = 6,
      IPLen = 15,
      ipMultiplier = 1,
      SBlLen = 6,
      SWLen = 8,
      BCLen = 9,
      AVALen = 20,
      TFBLen = 8,
      CSHLen = 10,
      threatThreshold = 90,
      DSLen = 8,
      LSLen = 15,
      enableTimeRemaining = false,
      enableDisableBorder = false,
      hideMaelstromBarOOC = false,
      enableRestoSpec = false,
      enableEnhancementSpec = true,
      enableElementalSpec = false,
      currentspec = "None",

      --Talents
      talHailstorm = false,
      talOvercharge = false,
      talHotHand = false,
      talBoulderfist = false,
      talCrashingStorm = false,

      --ShockAndAwe Announcements
      announce_skull_banner = true,
      announce_skull_banner_where = 1,
      announce_demoralizing_banner = true,
      announce_demoralizing_banner_where = 1,
      announce_mocking_banner = true,
      announce_mocking_banner_where = 1,
      announce_interrupt = true,
      announce_interrupt_where = 1,
      announce_laststand= true,
      announce_laststand_where = 1,
      announce_shieldwall= true,
      announce_shieldwall_where = 1,
      sBannerLen = 10,
      dBannerLen = 15,
      mBannerLen = 30,

      --ShockAndAwe CDs
      PurgeLen = 10,
      RagingBlowLen = 6,
      BloodthirstLen = 3,
      BattleShoutLen = 30,
      ColossusSmashLen = 20,
      AVALen = 90,
      DRLen = 6,
      ShockLen = 6,
      ShearLen = 6,
      lastshock = "",
      debug = false,
      msg = { r = 1, g = .5, b = 0, },
      msgtime = 2,
      newsitem = 0,
      castweaponrebuff = false,
      MSBToutputarea = "Notification",
      colors = {
        watershield = { r=.6, g=.6, b=1, a=.3 },
        lightningshield = { r=0, g=0, b=1, a=.5 },
        earthshield = { r=0, g=1, b=0, a=.5 },
        noshield = { r=1, g=0, b=0, a=1 },

        flameshock = { r=1, g=.6, b=.2, a=.9 },
        flameshockDot = { r=1, g=.6, b=.2, a=.6 },
        earthshock = { r=0, g=1, b=.3, a=.9 },
        frostshock = { r=.6, g=.6, b=1, a=.9 },
        windshear = { r=.6, g=.6, b=.6, a=.9 },
        magma = { r=.9, g=.4, b=0, a=.9 },
        feralspiritCD = { r=0, g=.6, b=.95, a=.9 },
        stormstrike = { r=1, g=1, b=.2, a=.9 },
        firenova = { r=1, g=.9, b=.4, a=.9 },
        windfury = { r=1, g=0, b=0, a=.5 },

        --ShockAndAwe

        maelstrom = { r=0, g=.2, b=1, a=.9 },
        sixtymaelstrom = { r=0, g=1, b=0, a=.9},
        bloodthirst = { r=0, g=1, b=.3, a=.9 },
        ragingblow = { r=0, g=1, b=.3, a=.9 },
        bloodsurge = { r=0, g=1, b=.3, a=.9 },
        slam = { r=0, g=1, b=.3, a=.9 },
        heroicstrike = { r=0, g=1, b=.3, a=.9 },
        purge = { r=0, g=1, b=.3, a=.9 },
        colossussmash = { r=1, g=.8, b=0, a=.9 },
        avatar = { r=.5, g=.8, b=1, a=.9 },
        dragonroar = { r=1, g=.8, b=0, a=.9 },
        tfb = { r=1, g=.5, b=1, a=.3 },
        tfbalpha = .3,
        tfbalphaFull = .9,
        battlecry = { r=1, g=.6, b=0, a=.9 },
        bloodbath = { r=1, g=.13, b=0, a=.9 },

        ignorepain = { r=.7, g=0, b=.7, a=.9 },
        shieldblock = { r=0, g=.8, b=0, a=.9 },
        shieldwall = { r=0, g=0, b=.8, a=.9 },
        demoshout = { r=0, g=.8, b=0, a=.9},
        laststand = { r=.8, g=.8, b=0, a=.9},
        commandingshout = {r=.1,g=.1,b=.8, a=.9},
      },
      uptime = {
        show = true,
        fWidth = 130,
        fHeight = 140,
        barWidth = 100,
        barHeight = 20,
        relativeTo = "UIParent",
        relativePoint = "RIGHT",
        point = "CENTER",
        xOffset = -100,
        yOffset = 0,
        alpha = 0.4,
        scale = 1,
        -- flurry = { r = .2, g = .1, b = 1, a = 0.5, },
        ip = { r = .2, g = .1, b = 1, a = 0.5, },
        sl = { r = 0, g = .2, b = .8, a = 0.5, },
        sb = { r = 1, g = .5, b = 0, a = 0.5, },
      },
      stats = {
        show = true,
        fWidth = 120,
        fHeight = 200,
        barWidth = 100,
        barHeight = 20,
        relativeTo = "ShockAndAwe.UptimeFrame",
        relativePoint = "TOPLEFT",
        point = "TOPLEFT",
        xOffset = 125,
        yOffset = 0,
        alpha = 0.4,
        scale = 1,
        wfcalc = true,
        wfcol = { r = 1, g = .5, b = 0, a = 0.8, },
        wftime = 2,
        best = {
          ap = 0,
          spellpower = 0,
          meleehit = 0,
          spellhit = 0,
          expertise = 0,
          meleecrit = 0,
          spellcrit = 0,
          wfmh = 0,
          wfoh = 0,
          stormstrike = 0,
        },
      },
      priority = {
        show = true,
        barborder = "Blizzard Tooltip",
        enableDisablePriorityBorder = "false",
        titleshow = false,
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 50,
        fHeight = 50,
        xOffset = -215,
        yOffset = -60,
        alpha = 0.4,
        scale = 1,
        next = 1,
        cooldown = 0.5,
        fsticksleft = 2,
        totemtimeleft = 20,
        srmaelstrom = 10,
        wsmaelstrom = 0,
        shieldorbs = 1,
        magmaticks = 2,
        firetotemtime = 0,
        searingticks = 0,
        worldbossonly = true,
        hideImmune = true,
        -- combopoints = true,
        showpurge = true,
        showinterrupt = true,
        showcooldown = true,
        prOption = ShockAndAwe.singleOptions,
        groupnumber = 1,
        prOptions = {
          ShockAndAwe.enhancementOptions,
          ShockAndAwe.restorationOptions,
          ShockAndAwe.elementalOptions,
          ShockAndAwe.emptyOptions,
          ShockAndAwe.emptyOptions }
      },
      maelstrombar = {
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 300,
        fHeight = 20,
        xOffset = 0,
        yOffset = -120,
        alpha = 1,
        scale = 1,
        framestratalevel = "LOW",
        enableDisableMaelstromBarBorder = "false",
        texture = "Blizzard",
        barfont = "Friz Quadrata TT",
        barfontsize = 12,
        barfonteffect = "none",
        barborder = "Blizzard Tooltip",
      },
      binding = {
        show = true,
        relativeTo = "UIParent",
        relativePoint = "CENTER",
        point = "CENTER",
        fWidth = 200,
        fHeight = 50,
        xOffset = -200,
        yOffset = -100,
        alpha = 0.4,
        scale = 1,
        mhspell = ShockAndAwe.constants["Windfury Weapon"],
        ohspell = ShockAndAwe.constants["Flametongue Weapon"],
        macroset = false,
      },
      warning = {
        show = true,
        duration = 3,
        shield = false,
        weapon = true,
        range = true,
        grounding = true,
        interrupt = true,
        purge = true,
        timeleft = 300,
        color = { r = 1, g = .5, b = 0, a = 0.5, },
        relativeTo = "UIParent",
        relativePoint = "TOP",
        point = "CENTER",
        fWidth = 600,
        fHeight = 100,
        xOffset = 0,
        yOffset = -250,
      },
    }
  }
end

function ShockAndAwe:VerifyOptions()
  ShockAndAwe.db.char.priority.option = nil -- remove old format of options
  ShockAndAwe.db.char.priority.options = nil
  if not ShockAndAwe.db.char.priority.prOption then -- fix for corruption in v5.50
    ShockAndAwe.db.char.priority.prOption = ShockAndAwe.emptyOptions
    ShockAndAwe:Print(L["ShockAndAwe Warning : No options set"])
  end
  for index = 1, 30 do
    if not ShockAndAwe.db.char.priority.prOption[index] then
      ShockAndAwe.db.char.priority.prOption[index] = "none"
    end
  end
  for group = 1, 5 do
    for index = 1, 30 do
      if not ShockAndAwe.db.char.priority.prOptions[group][index] then
        ShockAndAwe.db.char.priority.prOptions[group][index] = "none"
      end
    end
  end
end

function ShockAndAwe:GetOptions()
  local options = {
    name = "ShockAndAwe",
    handler = ShockAndAwe,
    type='group',
    childGroups ='tree',
    args = {
      priorities = {
        name = L["Set Priorities"],
        type='group',
        childGroups ='tree',
        order = 1,
        args = {
          prioritygroup = {
            type = 'select',
            name = L["Priority Group"],
            get = "GetPriorityGroup",
            set = "SetPriorityGroup",
            values = { L["Priority Group One"], L["Priority Group Two"], L["Priority Group Three"], L["Priority Group Four"], L["Priority Group Five"] },
            order = 100,
          },
          priority1 = {
            type = 'select',
            name = L["First Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(1),
            set = ShockAndAwe:SetPriority(1),
            values = ShockAndAwe.priorityTable.name,
            order = 101,
          },
          priority2 = {
            type = 'select',
            name = L["Second Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(2),
            set = ShockAndAwe:SetPriority(2),
            values = ShockAndAwe.priorityTable.name,
            order = 102,
          },
          priority3 = {
            type = 'select',
            name = L["Third Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(3),
            set = ShockAndAwe:SetPriority(3),
            values = ShockAndAwe.priorityTable.name,
            order = 103,
          },
          priority4 = {
            type = 'select',
            name = L["Fourth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(4),
            set = ShockAndAwe:SetPriority(4),
            values = ShockAndAwe.priorityTable.name,
            order = 104,
          },
          priority5 = {
            type = 'select',
            name = L["Fifth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(5),
            set = ShockAndAwe:SetPriority(5),
            values = ShockAndAwe.priorityTable.name,
            order = 105,
          },
          priority6 = {
            type = 'select',
            name = L["Sixth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(6),
            set = ShockAndAwe:SetPriority(6),
            values = ShockAndAwe.priorityTable.name,
            order = 106,
          },
          priority7 = {
            type = 'select',
            name = L["Seventh Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(7),
            set = ShockAndAwe:SetPriority(7),
            values = ShockAndAwe.priorityTable.name,
            order = 107,
          },
          priority8 = {
            type = 'select',
            name = L["Eighth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(8),
            set = ShockAndAwe:SetPriority(8),
            values = ShockAndAwe.priorityTable.name,
            order = 108,
          },
          priority9 = {
            type = 'select',
            name = L["Ninth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(9),
            set = ShockAndAwe:SetPriority(9),
            values = ShockAndAwe.priorityTable.name,
            order = 109,
          },
          priority10 = {
            type = 'select',
            name = L["Tenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(10),
            set = ShockAndAwe:SetPriority(10),
            values = ShockAndAwe.priorityTable.name,
            order = 110,
          },
          priority11 = {
            type = 'select',
            name = L["Eleventh Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(11),
            set = ShockAndAwe:SetPriority(11),
            values = ShockAndAwe.priorityTable.name,
            order = 111,
          },
          priority12 = {
            type = 'select',
            name = L["Twelfth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(12),
            set = ShockAndAwe:SetPriority(12),
            values = ShockAndAwe.priorityTable.name,
            order = 112,
          },
          priority13 = {
            type = 'select',
            name = L["Thirteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(13),
            set = ShockAndAwe:SetPriority(13),
            values = ShockAndAwe.priorityTable.name,
            order = 113,
          },
          priority14 = {
            type = 'select',
            name = L["Fourteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(14),
            set = ShockAndAwe:SetPriority(14),
            values = ShockAndAwe.priorityTable.name,
            order = 114,
          },
          priority15 = {
            type = 'select',
            name = L["Fifteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(15),
            set = ShockAndAwe:SetPriority(15),
            values = ShockAndAwe.priorityTable.name,
            order = 115,
          },
          priority16 = {
            type = 'select',
            name = L["Sixteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(16),
            set = ShockAndAwe:SetPriority(16),
            values = ShockAndAwe.priorityTable.name,
            order = 116,
          },
          priority17 = {
            type = 'select',
            name = L["Seventeenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(17),
            set = ShockAndAwe:SetPriority(17),
            values = ShockAndAwe.priorityTable.name,
            order = 117,
          },
          priority18 = {
            type = 'select',
            name = L["Eighteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(18),
            set = ShockAndAwe:SetPriority(18),
            values = ShockAndAwe.priorityTable.name,
            order = 118,
          },
          priority19 = {
            type = 'select',
            name = L["Nineteenth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(19),
            set = ShockAndAwe:SetPriority(19),
            values = ShockAndAwe.priorityTable.name,
            order = 119,
          },
          priority20 = {
            type = 'select',
            name = L["Twentieth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(20),
            set = ShockAndAwe:SetPriority(20),
            values = ShockAndAwe.priorityTable.name,
            order = 120,
          },
          priority21= {
            type = 'select',
            name = L["Twentyfirst Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(21),
            set = ShockAndAwe:SetPriority(21),
            values = ShockAndAwe.priorityTable.name,
            order = 121,
          },
          priority22 = {
            type = 'select',
            name = L["Twentysecond Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(22),
            set = ShockAndAwe:SetPriority(22),
            values = ShockAndAwe.priorityTable.name,
            order = 122,
          },
          priority23 = {
            type = 'select',
            name = L["Twentythird Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(23),
            set = ShockAndAwe:SetPriority(23),
            values = ShockAndAwe.priorityTable.name,
            order = 123,
          },
          priority24 = {
            type = 'select',
            name = L["Twentyfourth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(24),
            set = ShockAndAwe:SetPriority(24),
            values = ShockAndAwe.priorityTable.name,
            order = 124,
          },
          priority25 = {
            type = 'select',
            name = L["Twentyfifth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(25),
            set = ShockAndAwe:SetPriority(25),
            values = ShockAndAwe.priorityTable.name,
            order = 125,
          },
          priority26 = {
            type = 'select',
            name = L["Twentysixth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(26),
            set = ShockAndAwe:SetPriority(26),
            values = ShockAndAwe.priorityTable.name,
            order = 126,
          },
          priority27 = {
            type = 'select',
            name = L["Twentyseventh Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(27),
            set = ShockAndAwe:SetPriority(27),
            values = ShockAndAwe.priorityTable.name,
            order = 127,
          },
          priority28 = {
            type = 'select',
            name = L["Twentyeighth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(28),
            set = ShockAndAwe:SetPriority(28),
            values = ShockAndAwe.priorityTable.name,
            order = 128,
          },
          priority29 = {
            type = 'select',
            name = L["Twentyninth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(29),
            set = ShockAndAwe:SetPriority(29),
            values = ShockAndAwe.priorityTable.name,
            order = 129,
          },
          priority30 = {
            type = 'select',
            name = L["Thirtieth Priority"],
            width = 'full',
            get = ShockAndAwe:GetPriority(30),
            set = ShockAndAwe:SetPriority(30),
            values = ShockAndAwe.priorityTable.name,
            order = 130,
          },
        },
      },

      priority = {
        name = L["Priority Options"],
        type = 'group',
        childGroups = 'tab',
        order = 2,
        args = {
          priority_general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {

              priority = {
                type = 'toggle',
                name = L["Priority Frame"],
                desc = L["help_priority"],
                get = "priorityQuery",
                set = "ActivatePriority",
                order = 40,
              },

              showinterrupt = {
                type = 'toggle',
                name = L["Show Interrupt"],
                desc = L["help_showinterrupt"],
                get = "showinterruptQuery",
                set = "ActivateShowInterrupt",
                order = 41,
              },

              -- heroicstrike = {
              -- type = 'toggle',
              -- name = ShockAndAwe.constants["Heroic Strike"],
              -- desc = L["help_heroicstrike"],
              -- get = "heroicstrikeQuery",
              -- set = "ActivateHeroicStrike",
              -- order = 44,
              -- },
              -- maelstrom = {
              -- type = 'range',
              -- name = L["HS Maelstrom Threshold"],
              -- desc = L["help_hsmaelstrom"],
              -- min = 1,
              -- max = 120,
              -- step = 1,
              ---- get = "GetMaelstromThreshold",
              -- set = "SetMaelstromThreshold",
              -- order = 45,
              -- },
              showcooldown = {
                type = 'toggle',
                name = L["Show Cooldown"],
                desc = L["help_showcooldown"],
                get = "showcooldownQuery",
                set = "ActivateShowCooldown",
                order = 42,
              },
              cooldown = {
                type = 'range',
                name = L["Cooldown Threshold"],
                desc = L["help_cooldown"],
                min = 0,
                max = 1.5,
                step = 0.05,
                get = "GetCooldownThreshold",
                set = "SetCooldownThreshold",
                order = 43,
              },

              -- threat = {
              -- type = 'range',
              -- name = L["Threat Threshold"],
              -- desc = L["help_threat"],
              -- min = 75,
              -- max = 110,
              -- step = 1,
              -- get = "GetThreatThreshold",
              -- set = "SetThreatThreshold",
              -- guiHidden = true,
              -- order = 47,
              -- },

            },
          },

          priority_Display = {
            type = "group",
            order= 201,
            name = L["Display"],
            args = {
              priorityscale = {
                type = 'range',
                name = L["Priority Bar Scale"],
                desc = L["help_priority_scale"],
                min = 0.50,
                max = 3.00,
                step = 0.01,
                get = "GetPriorityScale",
                set = "SetPriorityScale",
                order = 41,
              },

              resetpriority = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_reset_priority_frame"],
                func = "ResetPriority",
                order = 49,
              },
            },
          },
          priority_media = {
            type = "group",
            order= 202,
            name = L["Media"],
            args = {
              title = {
                type = 'toggle',
                name = L["Display frame title"],
                get = "priorityTitleQuery",
                set = "ActivatePriorityTitle",
                order = 6,
              },

              priority_barborder = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetPriorityBorderTexture",
                set = "SetPriorityBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 7,
              },
              priority_enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Border"],
                desc = L["help_enableDisablePriorityBorder"],
                get = "enableDisablePriorityBorderQuery",
                set = "ActivateEnableDisablePriorityBorder",
                order = 8,
              },

              -- priority_enableDisableBorder = {
              -- type = 'toggle',
              -- name = L["Disable Borders"],
              -- desc = L["help_enableDisableBorder"],
              -- get = "enableDisablePriorityBorderQuery",
              -- set = "ActivateEnableDisablePriorityBorder",
              -- order = 8,
              -- },
            },
          },

        },
      },

      bars = {
        name = L["General Bar Options"],
        type = 'group',
        childGroups = 'tab',
        order = 3,
        args = {
          general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {
              enableTimeRemaining = {
                type = 'toggle',
                name = L["Enable Time Remaining"],
                desc = L["help_enableTimeRemaining"],
                get = "enableTimeRemainingQuery",
                set = "ActivateEnableTimeRemaining",
                order = 2,
              },

              abc = {
                type = 'toggle',
                name = L["Show bar icons"],
                desc = L["help_baricons"],
                get = "bariconsQuery",
                set = "ActivateBarIcons",
                order = 2,
              },
              icons = {
                type = 'toggle',
                name = L["Show bar icons"],
                desc = L["help_baricons"],
                get = "bariconsQuery",
                set = "ActivateBarIcons",
                order = 2,
              },
              gcdfullwidth = {
                type = 'toggle',
                name = L["GCD full width"],
                desc = L["help_gcd_fullwidth"],
                get = "gcdFullwidthQuery",
                set = "ActivateGCDfullwidth",
                order = 2
              },
              tb_break1 = {
                type = 'header',
                name = L["Misc Bars"],
                order = 3,
              },
              gcd = {
                type = 'toggle',
                name = L["GCD"],
                desc = L["help_gcd"],
                get = "gcdQuery",
                set = "ActivateGCD",
                order = 4,
              },--[[
              CSHBar = {
                type = 'toggle',
                name = L["Commanding Shout Bar"],
                desc = L["help_CSH"],
                get = "commandingShoutQuery",
                set = "ActivateCommandingShout",
                order = 5,
              },]]
              tb_break2 = {
                type = 'header',
                name = L["DPS Bars"],
                order = 6,
              },--[[
              CSbar = {
                type = 'toggle',
                name = L["Colossus Smash Bar"],
                desc = L["help_CS"],
                get = "colossussmashQuery",
                set = "ActivateColossusSmash",
                order = 7,
              },
              tfbbar = {
                type = 'toggle',
                name = L["Taste for Blood Bar"],
                desc = L["help_tfb"],
                get = "tfbQuery",
                set = "ActivateTasteForBlood",
                order = 8,
              },
              AVAbar = {
                type = 'toggle',
                name = L["Avatar Bar"],
                desc = L["help_AVA"],
                get = "avatarQuery",
                set = "ActivateAvatar",
                order = 9,
              },
              DCbar = {
                type = 'toggle',
                name = L["Battle Cry Bar"],
                desc = L["help_BC"],
                get = "battlecryQuery",
                set = "ActivateBattleCry",
                order = 10,
              },
              BBbar = {
                type = 'toggle',
                name = L["Bloodbath Bar"],
                desc = L["help_RE"],
                get = "bloodbathQuery",
                set = "ActivateBloodbath",
                order = 11,
              },
              DRbar = {
                type = 'toggle',
                name = L["Dragon Roar Bar"],
                desc = L["help_DR"],
                get = "dragonroarQuery",
                set = "ActivateDragonRoar",
                order = 12,
              },
              tb_break3 = {
                type = 'header',
                name = L["Restoration Bars"],
                order = 13,
              },
              IPbar = {
                type = 'toggle',
                name = L["Ignore Pain Bar"],
                desc = L["help_IP"],
                get = "ignorepainQuery",
                set = "ActivateIgnorePain",
                order = 14,
              },
              SBlbar = {
                type = 'toggle',
                name = L["Shield Block Bar"],
                desc = L["help_SBl"],
                get = "shieldblockQuery",
                set = "ActivateShieldBlock",
                order = 15,
              },
              SWbar = {
                type = 'toggle',
                name = L["Shield Wall Bar"],
                desc = L["help_SW"],
                get = "shieldwallQuery",
                set = "ActivateShieldWall",
                order = 16,
              },
              LSBar = {
                type = 'toggle',
                name = L["Last Stand Bar"],
                desc = L["help_LS"],
                get = "lastStandQuery",
                set = "ActivateLastStand",
                order = 17,
              },
              DSBar = {
                type = 'toggle',
                name = L["Demoralizing Shout Bar"],
                desc = L["help_DS"],
                get = "demoShoutQuery",
                set = "ActivateDemoShout",
                order = 18,
              },]]
            },
          },
          colors = {
            type = "group",
            order= 201,
            name = L["Colors"],
            args = {
              bc_break1 = {
                type = 'header',
                name = L["Misc Bars"],
                order = 1,
              },--[[
              commandingshout = {
                type = 'color',
                name = L["Commanding Shout Bar Color"],
                desc = L["colCommandingShout"],
                get = "getCommandingShoutColor",
                set = "setCommandingShoutColor",
                hasAlpha = true,
                order = 2,
              },]]
              bc_break2 = {
                type = 'header',
                name = L["DPS Bars"],
                order = 3,
              },--[[
              ColossusSmash = {
                type = 'color',
                name = L["Colossus Smash Bar Color"],
                desc = L["colColossusSmash"],
                get = "getColossusSmashColor",
                set = "setColossusSmashColor",
                hasAlpha = true,
                order = 4,
              },
              BattleCry = {
                type = 'color',
                name = L["Battle Cry Bar Color"],
                desc = L["colBattleCry"],
                get = "getBattleCryColor",
                set = "setBattleCryColor",
                hasAlpha = true,
                order = 5,
              },
              Bloodbath = {
                type = 'color',
                name = L["Bloodbath Bar Color"],
                desc = L["colBloodbath"],
                get = "getBloodbathColor",
                set = "setBloodbathColor",
                hasAlpha = true,
                order = 6,
              },
              Avatar = {
                type = 'color',
                name = L["Avatar Bar Color"],
                desc = L["colAvatar"],
                get = "getAvatarColor",
                set = "setAvatarColor",
                hasAlpha = true,
                order = 7,
              },
              DragonRoar = {
                type = 'color',
                name = L["Dragon Roar Bar Color"],
                desc = L["colDragonRoar"],
                get = "getDragonRoarColor",
                set = "setDragonRoarColor",
                hasAlpha = true,
                order = 8,
              },
              tfb = {
                type = 'color',
                name = L["Taste for Blood Bar Color"],
                desc = L["colTasteForBlood"],
                get = "getTasteForBloodColor",
                set = "setTasteForBloodColor",
                hasAlpha = false,
                order = 9,
              },
              tfbalpha = {
                type = 'range',
                name = L["Taste for Blood Alpha"],
                desc = L["colTasteForBloodAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetTFBalpha",
                set = "SetTFBalpha",
                order = 10,
              },
              tfbalphaFull = {
                type = 'range',
                name = L["Taste for Blood Full Alpha"],
                desc = L["colTasteForBloodFullAlpha"],
                min = 0,
                max = 1,
                isPercent = true,
                get = "GetTFBalphaFull",
                set = "SetTFBalphaFull",
                order = 11,
              },]]
              bc_break3 = {
                type = 'header',
                name = L["Restoration Bars"],
                order = 12,
              },--[[
              IgnorePain= {
                type = 'color',
                name = L["Ignore Pain Color"],
                desc = L["colIgnorePain"],
                get = "getIgnorePainColor",
                set = "setIgnorePainColor",
                hasAlpha = true,
                order = 13,
              },
              ShieldBlock = {
                type = 'color',
                name = L["Shield Block Color"],
                desc = L["colShieldBlock"],
                get = "getShieldBlockColor",
                set = "setShieldBlockColor",
                hasAlpha = true,
                order = 14,
              },
              ShieldWall = {
                type = 'color',
                name = L["Shield Wall Color"],
                desc = L["colShieldWall"],
                get = "getShieldWallColor",
                set = "setShieldWallColor",
                hasAlpha = true,
                order = 15,
              },
              demoshout = {
                type = 'color',
                name = L["Demoralizing Shout Color"],
                desc = L["colDemoShout"],
                get = "getDemoShoutColor",
                set = "setDemoShoutColor",
                hasAlpha = true,
                order = 16,
              },
              laststand = {
                type = 'color',
                name = L["Last Stand Color"],
                desc = L["colLastStand"],
                get = "getLastStandColor",
                set = "setLastStandColor",
                hasAlpha = true,
                order = 17,
              },]]
            },
          },
          Display = {
            type = "group",
            order= 203,
            name = L["Display"],
            args = {
              width = {
                type = 'range',
                name = L["Bar Width"],
                desc = L["help_width"],
                min = 100,
                max = 600,
                step = 10,
                get = "GetWidth",
                set = "SetWidth",
                order = 10,
              },
              height = {
                type = 'range',
                name = L["Bar Height"],
                desc = L["help_height"],
                min = 100,
                max = 700,
                step = 10,
                get = "GetHeight",
                set = "SetHeight",
                order = 11,
              },
              scale = {
                type = 'range',
                name = L["Bar Scale"],
                desc = L["help_scale"],
                min = 0.10,
                max = 2.00,
                step = 0.05,
                get = "GetScale",
                set = "SetScale",
                order = 12,
              },
              framestrata = {
                type = 'select',
                name = L["Frame Strata"],
                get = "getFrameStrataLevel",
                set = "setFrameStrataLevel",
                values = { L["BACKGROUND"], L["LOW"], L["MEDIUM"], L["HIGH"] },
                order = 13,
              },
              resetbars = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_reset"],
                func = "ResetBars",
                order = 14,
              },

            },
          },

          media = {
            type = "group",
            order= 204,
            name = L["Media"],
            args = {
              texture = {
                type = 'select', dialogControl = 'LSM30_Statusbar',
                name = L["Bar Texture"],
                get = "GetBarTexture",
                set = "SetBarTexture",
                values = AceGUIWidgetLSMlists.statusbar,
                order = 2,
              },
              barborder = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetBarBorderTexture",
                set = "SetBarBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 3,
              },
              enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Borders"],
                desc = L["help_enableDisableBorder"],
                get = "enableDisableBorderQuery",
                set = "ActivateEnableDisableBorder",
                order = 7,
              },
              barfont = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Bar Font"],
                get = "GetBarFont",
                set = "SetBarFont",
                values = AceGUIWidgetLSMlists.font,
                order = 4,
              },
              barfonteffect = {
                name = L["Bar Font Effect"],
                type = "select",
                get = "GetBarFontEffect",
                set = "SetBarFontEffect",
                values = ShockAndAwe.fonteffects,
                order = 5,
              },

              barfontsize = {
                type = 'range',
                name = L["Bar Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetBarFontSize",
                set = "SetBarFontSize",
                order = 13,
              },
            },
          },

        },
      },

      maelstrombaroptions = {
        name = L["Maelstrom Bar Options"],
        type = 'group',
        childGroups = 'tab',
        order = 4,
        args = {
          maelstrombaroptions_general = {
            type = "group",
            order= 200,
            name = L["General"],
            args = {
              maelstrom_bar = {
                type = 'toggle',
                name = L["Maelstrom Bar"],
                desc = L["help_Maelstrom"],
                get = "maelstrombarQuery",
                set = "ActivateMaelstrom",
                order = 1,
              },
              hideMaelstromBarOOC = {
                type = 'toggle',
                name = L["Hide Maelstrom Bar Out of Combat"],
                desc = L["help_hideMaelstromBarOOC"],
                get = "hideMaelstromBarOOCQuery",
                set = "ActivateHideMaelstromBarOOC",
                order = 2,
              },
            },
          },

          maelstrombaroptions_colors = {
            type = "group",
            order= 201,
            name = L["Colors"],
            args = {
              Maelstrom = {
                type = 'color',
                name = L["Maelstrom Bar Color"],
                desc = L["Maelstrom Bar Color"],
                get = "getMaelstromColor",
                set = "setMaelstromColor",
                hasAlpha = true,
                order = 2,
              },
              sixtymaelstrom = {
                type = 'color',
                name = L["Maelstrom Bar Color > 60"],
                desc = L["help_maelstrom_60"],
                get = "getSixtyMaelstromColor",
                set = "setSixtyMaelstromColor",
                hasAlpha = true,
                order = 2,
              },
            },
          },

          maelstrombaroptions_Display = {
            type = "group",
            order= 202,
            name = L["Display"],
            args = {
              maelstrombar_width = {
                type = 'range',
                name = L["Bar Width"],
                desc = L["help_width"],
                min = 100,
                max = 1200,
                step = 5,
                get = "GetMaelstromBarWidth",
                set = "SetMaelstromBarWidth",
                order = 30,
              },
              maelstrombar_height = {
                type = 'range',
                name = L["Bar Height"],
                desc = L["help_height"],
                min = 20,
                max = 600,
                step = 5,
                get = "GetMaelstromBarHeight",
                set = "SetMaelstromBarHeight",
                order = 31,
              },
              maelstrombar_scale = {
                type = 'range',
                name = L["Bar Scale"],
                desc = L["help_scale"],
                min = 0.10,
                max = 2.00,
                step = 0.05,
                get = "GetMaelstromBarScale",
                set = "SetMaelstromBarScale",
                order = 32,
              },

              maelstromframe_strata = {
                type = 'select',
                name = L["Frame Strata"],
                get = "getFrameStrataLevel",
                set = "setFrameStrataLevel",
                values = { L["BACKGROUND"], L["LOW"], L["MEDIUM"], L["HIGH"] },
                order = 33,
              },

              maelstrom_reset = {
                type = 'execute',
                name = L["Reset"],
                desc = L["help_maelstrom_reset"],
                func = "ResetMaelstromBar",
                order = 40,
              },

            },
          },

          maelstrombaroptions_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              maelstrombar_texture = {
                type = 'select', dialogControl = 'LSM30_Statusbar',
                name = L["Bar Texture"],
                get = "GetMaelstromBarTexture",
                set = "SetMaelstromBarTexture",
                values = AceGUIWidgetLSMlists.statusbar,
                order = 2,
              },
              maelstrombar_border = {
                type = 'select', dialogControl = 'LSM30_Border',
                name = L["Bar Border Texture"],
                get = "GetMaelstromBarBorderTexture",
                set = "SetMaelstromBarBorderTexture",
                values = AceGUIWidgetLSMlists.border,
                order = 3,
              },
              maelstrombar_enableDisableBorder = {
                type = 'toggle',
                name = L["Disable Borders"],
                desc = L["help_enableDisableBorder"],
                get = "enableDisableMaelstromBarBorderQuery",
                set = "ActivateEnableDisableMaelstromBarBorder",
                order = 7,
              },
              maelstrombar_font = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Bar Font"],
                get = "GetMaelstromBarFont",
                set = "SetMaelstromBarFont",
                values = AceGUIWidgetLSMlists.font,
                order = 4,
              },
              maelstrombar_fonteffect = {
                name = L["Bar Font Effect"],
                type = "select",
                get = "GetMaelstromBarFontEffect",
                set = "SetMaelstromBarFontEffect",
                values = ShockAndAwe.fonteffects,
                order = 5,
              },

              maelstrombar_fontsize = {
                type = 'range',
                name = L["Bar Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetMaelstromBarFontSize",
                set = "SetMaelstromBarFontSize",
                order = 13,
              },

            },
          },

        },
      },

      announcer = {
        name = L["Announcer Options"],
        type = 'group',
        childGroups = 'tab',
        order = 5,
        args = {

          announcer_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              -- announcer_b1 = {
              -- type = 'header',
              -- name = L["Banners"],
              -- order = 1,
              -- },
              -- announceskullbanner = {
              -- type = 'toggle',
              -- name = L["Skull Banner"],
              -- desc = L["help_skull_banner"],
              -- get = "SkullBannerAnnounceQuery",
              -- set = "ActivateAnnounceSkullBanner",
              -- order = 2,
              -- },
              -- announceskullbannerwhere = {
              -- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetSkullBannerAnnounceLocation",
              -- set = "SetSkullBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 3,
              -- },
              -- announcedemoralizingbanner = {
              -- type = 'toggle',
              -- name = L["Demoralizing Banner"],
              -- desc = L["help_demoralizing_banner"],
              -- get = "DemoralizingBannerAnnounceQuery",
              -- set = "ActivateAnnounceDemoralizingBanner",
              -- order = 5,
              -- },
              -- announcedemoralizingbannerwhere = {
              --- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetDemoralizingBannerAnnounceLocation",
              -- set = "SetDemoralizingBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 6,
              -- },
              -- announcemockingbanner = {
              -- type = 'toggle',
              -- name = L["Mocking Banner"],
              -- desc = L["help_mocking_banner"],
              -- get = "MockingBannerAnnounceQuery",
              -- set = "ActivateAnnounceMockingBanner",
              -- order = 8,
              -- },
              -- announcemockingbannerwhere = {
              -- type = 'select',
              -- name = L["Output Location"],
              -- get = "GetMockingBannerAnnounceLocation",
              -- set = "SetMockingBannerAnnounceLocation",
              -- values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
              -- order = 9,
              -- },
              -- announcer_b2 = {
              -- type = 'header',
              -- name = L["Cooldowns"],
              -- order = 10,
              -- },

              announceinterrupt = {
                type = 'toggle',
                name = L["Spell Interrupts"],
                desc = L["help_announce_interrupt"],
                get = "InterruptAnnounceQuery",
                set = "ActivateAnnounceInterrupt",
                order = 12,
              },
              announceinterruptwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetInterruptAnnounceLocation",
                set = "SetInterruptAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 13,
              },

        --[[      announcelaststand = {
                type = 'toggle',
                name = ShockAndAwe.constants["Last Stand"],
                desc = L["help_announce_laststand"],
                get = "LastStandAnnounceQuery",
                set = "ActivateAnnounceLastStand",
                order = 15,
              },
              announcelaststandwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetLastStandAnnounceLocation",
                set = "SetLastStandAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 16,
              },

              announceshieldwall = {
                type = 'toggle',
                name = ShockAndAwe.constants["Shield Wall"],
                desc = L["help_announce_shieldwall"],
                get = "ShieldWallAnnounceQuery",
                set = "ActivateAnnounceShieldWall",
                order = 18,
              },

              announceshieldwallwhere = {
                type = 'select',
                name = L["Output Location"],
                get = "GetShieldWallAnnounceLocation",
                set = "SetShieldWallAnnounceLocation",
                values = { L["SAY"], L["YELL"], L["PARTY"], L["RAID"] },
                order = 19,
              },]]

            },
          },

        },
      },

      uptime = {
        name = L["Uptime Options"],
        type = 'group',
        childGroups = 'tab',
        order = 8,
        args = {
          uptime_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              resetuptime = {
                type = 'execute',
                name = L["Reset Uptime Frame"],
                desc = L["help_reset_uptime_frame"],
                func = "ResetUptime",
                order = 14,
              },
              show = {
                type = 'toggle',
                name = L["Show Frame"],
                desc = L["help_showuptime"],
                get = "showUptimeQuery",
                set = "ActivateShowUptime",
                order = 84,
              },
              resetsession = {
                type = 'execute',
                name = L["Reset Session info"],
                desc = L["help_reset_session"],
                func = "ResetUptimeValues",
                order = 85,
              },
            },
          },

          uptime_colors = {
            type = "group",
            order= 202,
            name = L["Colors"],
            args = {

              en = {
                type = 'color',
                name = L["Stormlash Color"],
                desc = L["colEN"],
                get = "getSLColor",
                set = "setSLColor",
                hasAlpha = true,
                order = 62,
              },--[[
              ip = {
                type = 'color',
                name = L["Ignore Pain Color"],
                desc = L["colIP"],
                get = "getIPColor",
                set = "setIPColor",
                hasAlpha = true,
                order = 63,
              },
              sb = {
                type = 'color',
                name = L["Shield Block Color"],
                desc = L["colSB"],
                get = "getSBColor",
                set = "setSBColor",
                hasAlpha = true,
                order = 63,
              }, ]]
              -- flurry = {
              -- type = 'color',
              -- name = L["Flurry Color"],
              -- desc = L["colFlurry"],
              -- get = "getFlurryColor",
              -- set = "setFlurryColor",
              --hasAlpha = true
              --order = 81,
              --},
              -- ip = {
              -- type = 'color',
              -- name = L["Ignore Pain Color"],
              -- desc = L["colIgnorePain"],
              -- get = "getIgnorePainColor",
              -- set = "setIgnorePainColor",
              --hasAlpha = true,
              --order = 81,
              --},
            },
          },

          uptime_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              uptime_media_br1 = {
                type = 'header',
                name = L["Coming Soon"],
                order = 3,
              },
            },
          },

        },
      },

      warning = {
        name = L["Warning Options"],
        type = 'group',
        childGroups = 'tab',
        order = 8,
        args = {
          warning_general = {
            type = "group",
            order= 201,
            name = L["General"],
            args = {
              show = {
                type = 'toggle',
                name = L["Use Warning Frame"],
                desc = L["help_warningframe"],
                get = "WarningFrameQuery",
                set = "ActivateWarningFrame",
                order = 60,
              },

              range = {
                type = 'toggle',
                name = L["Out of range"],
                desc = L["help_outofrange"],
                get = "rangeWarnQuery",
                set = "ActivateRangeWarn",
                order = 61,
              },
              interrupt = {
                type = 'toggle',
                name = L["Interrupt Warning"],
                desc = L["help_interruptwarning"],
                get = "interruptWarnQuery",
                set = "ActivateInterruptWarn",
                order = 62,
              },
              duration = {
                type = 'range',
                name = L["Warning Message Duration"],
                min = 1,
                max = 10,
                step = .2,
                get = "GetWarningDuration",
                set = "SetWarningDuration",
                order = 64,
              },
            },
          },
          warning_colors = {
            type = "group",
            order= 202,
            name = L["Colors"],
            args = {

              warningcolor = {
                type = 'color',
                name = L["Warning Msg Color"],
                desc = L["colWarningMessage"],
                get = "getWarningColor",
                set = "setWarningColor",
                hasAlpha = true,
                order = 63,
              },
            },
          },
          warning_media = {
            type = "group",
            order= 203,
            name = L["Media"],
            args = {

              msgfont = {
                type = 'select', dialogControl = 'LSM30_Font',
                name = L["Message Font"],
                get = "GetMsgFont",
                set = "SetMsgFont",
                values = AceGUIWidgetLSMlists.font,
                order = 31,
              },
              msgfonteffect = {
                name = L["Message Font Effect"],
                type = "select",
                get = "GetMsgFontEffect",
                set = "SetMsgFontEffect",
                values = ShockAndAwe.fonteffects,
                order = 32,
              },
              msgfontsize = {
                type = 'range',
                name = L["Message Font Size"],
                min = 6,
                max = 64,
                step = 1,
                get = "GetMsgFontSize",
                set = "SetMsgFontSize",
                order = 33,
              },
            },
          },
          --~ msbt = {
          --~ type = 'select',
          --~ name = L["MSBT output area"],
          --~ get = "GetMSBTareas",
          --~ set = "SetMSBTareas",
          --~ values = ShockAndAwe.MSBT.areas,
          --~ order = 12,
          --~ },
          --~ rebuff = {
          --~ type = 'range',
          --~ name = L["Weapon Rebuff time"],
          --~ desc = L["help_weaponrebuff"],
          --~ min = 0,
          --~ max = 900,
          --~ step = 10,
          --~ get = "GetRebuffTime",
          --~ set = "SetRebuffTime",
          --~ order = 6,
          --~ },
        },
      },

      debug = {
        type = 'toggle',
        name = L["Debug mode"],
        desc = L["help_debug"],
        get = "debugQuery",
        set = "ActivateDebug",
        order = 99,
      },
      moveframes = {
        type = 'toggle',
        name = L["Move Frames"],
        desc = L["help_display"],
        get = "MovingFramesQuery",
        set = "ShowHideBars",
        order = 100,
      },
      -- specchangewarning = {
      -- type = 'toggle',
      -- name = L["Warn on Spec Change"],
      -- desc = L["help_specchangewarning"],
      -- get = "specchangewarningQuery",
      -- set = "Activatespecchangewarning",
      -- order = 92,
      -- },
      resetdefaults = {
        type = 'execute',
        name = L["Reset Defaults"],
        desc = L["help_resetdefaults"],
        func = "ResetToDefault",
        order = 101,
      },
      enable = {
        type = 'execute',
        name = L["Enable/Disable"],
        desc = L["help_disable"],
        func = "EnableDisable",
        order = 98,
      },
      disable = {
        type = 'execute',
        name = L["Enable/Disable"],
        desc = L["help_disable"],
        func = "EnableDisable",
        guiHidden = true,
        order = 99,
      },

      enableRestoSpec = {
        type = 'toggle',
        name = L["Enable Addon - Resto"],
        desc = L["help_enableRestoSpec"],
        get = "enableRestoSpecQuery",
        set = "ActivateRestoSpec",
        order = 94,
        disabled = true,
      },
      enableElementalSpec = {
        type = 'toggle',
        name = L["Enable Addon - Elemental"],
        desc = L["help_enableElementalSpec"],
        get = "enableElementalSpecQuery",
        set = "ActivateElementalSpec",
        order = 92,
      },
      enableEnhancementSpec = {
        type = 'toggle',
        name = L["Enable Addon - Enhancement"],
        desc = L["help_enableEnhancementSpec"],
        get = "enableEnhancementSpecQuery",
        set = "ActivateEnhancementSpec",
        order = 93,
      },
      config = {
        type = 'execute',
        name = L["Configure Options"],
        desc = L["help_config"],
        func = "OpenConfig",
        guiHidden = true,
        order = 95,
      },
      version = {
        type = 'execute',
        name = L["Version"],
        desc = L["help_version"],
        func = "DisplayVersion",
        order = 96,
        guiHidden = true,
      },
      help = {
        type = 'description',
        name = L["help"],
        guiHidden = true,
        order = 97,
      },
    }
  }
  return options
end

function ShockAndAwe:ActivateShear()
  ShockAndAwe.db.char.shearshow = not ShockAndAwe.db.char.shearshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.shearshow) then
    ShockAndAwe:Print(L["config_Shear_on"])
  else
    ShockAndAwe:Print(L["config_Shear_off"])
  end
end

function ShockAndAwe:ActivateShowUptime()
  ShockAndAwe.db.char.uptime.show = not ShockAndAwe.db.char.uptime.show
  if (ShockAndAwe.db.char.uptime.show) and not ShockAndAwe.db.char.disabled then
    ShockAndAwe.UptimeFrame:Show()
    ShockAndAwe:Print(L["config_Uptime_on"])
  else
    ShockAndAwe.UptimeFrame:Hide()
    ShockAndAwe:Print(L["config_Uptime_off"])
  end
end

function ShockAndAwe:ActivateTasteForBlood()
  ShockAndAwe.db.char.tfbshow = not ShockAndAwe.db.char.tfbshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.tfbshow) then
    ShockAndAwe:Print(L["config_tfb_on"])
  else
    ShockAndAwe:Print(L["config_tfb_off"])
  end
end

function ShockAndAwe:ActivateColossusSmash()
  ShockAndAwe.db.char.csshow = not ShockAndAwe.db.char.csshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.csshow) then
    ShockAndAwe:Print(L["config_CS_on"])
  else
    ShockAndAwe.frames["ColossusSmash"]:Hide()
    ShockAndAwe:Print(L["config_CS_off"])
  end
end

function ShockAndAwe:ActivateAvatar()
  ShockAndAwe.db.char.avashow = not ShockAndAwe.db.char.avashow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.avashow) then
    ShockAndAwe:Print(L["config_AVA_on"])
  else
    ShockAndAwe.frames["Avatar"]:Hide()
    ShockAndAwe:Print(L["config_AVA_off"])
  end
end

function ShockAndAwe:ActivateDragonRoar()
  ShockAndAwe.db.char.drshow = not ShockAndAwe.db.char.drshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.drshow) then
    ShockAndAwe:Print(L["config_DR_on"])
  else
    ShockAndAwe.frames["DragonRoar"]:Hide()
    ShockAndAwe:Print(L["config_DR_off"])
  end
end

function ShockAndAwe:ActivateBattleCry()
  ShockAndAwe.db.char.bcshow = not ShockAndAwe.db.char.bcshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.bcshow) then
    ShockAndAwe:Print(L["config_BC_on"])
  else
    ShockAndAwe.frames["BattleCry"]:Hide()
    ShockAndAwe:Print(L["config_BC_off"])
  end
end

function ShockAndAwe:ActivateBloodbath()
  ShockAndAwe.db.char.bbshow = not ShockAndAwe.db.char.bbshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.bbshow) then
    ShockAndAwe:Print(L["config_BB_on"])
  else
    ShockAndAwe.frames["Bloodbath"]:Hide()
    ShockAndAwe:Print(L["config_BB_off"])
  end
end

function ShockAndAwe:ActivateShieldBlock()
  ShockAndAwe.db.char.sblshow = not ShockAndAwe.db.char.sblshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.sblshow) then
    ShockAndAwe:Print(L["config_SBl_on"])
  else
    ShockAndAwe.frames["ShieldBlock"]:Hide()
    ShockAndAwe:Print(L["config_SBl_off"])
  end
end

function ShockAndAwe:ActivateShieldWall()
  ShockAndAwe.db.char.swshow = not ShockAndAwe.db.char.swshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.swshow) then
    ShockAndAwe:Print(L["config_SW_on"])
  else
    ShockAndAwe.frames["ShieldWall"]:Hide()
    ShockAndAwe:Print(L["config_SW_off"])
  end
end

function ShockAndAwe:ActivateLastStand()
  ShockAndAwe.db.char.laststandshow = not ShockAndAwe.db.char.laststandshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.laststandshow) then
    ShockAndAwe:Print(L["config_LS_on"])
  else
    ShockAndAwe.frames["LastStand"]:Hide()
    ShockAndAwe:Print(L["config_LS_off"])
  end
end
function ShockAndAwe:ActivateCommandingShout()
  ShockAndAwe.db.char.commandingshoutshow = not ShockAndAwe.db.char.commandingshoutshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.commandingshoutshow) then
    ShockAndAwe:Print(L["config_CSH_on"])
  else
    ShockAndAwe.frames["CommandingShout"]:Hide()
    ShockAndAwe:Print(L["config_CSH_off"])
  end
end
function ShockAndAwe:ActivateCommandingShout()
  ShockAndAwe.db.char.commandingshoutshow = not ShockAndAwe.db.char.commandingshoutshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.commandingshoutshow) then
    ShockAndAwe:Print(L["config_CSH_on"])
  else
    ShockAndAwe.frames["CommandingShout"]:Hide()
    ShockAndAwe:Print(L["config_CSH_off"])
  end
end
function ShockAndAwe:ActivateDemoShout()
  ShockAndAwe.db.char.demoshoutshow = not ShockAndAwe.db.char.demoshoutshow
  ShockAndAwe:CreateBaseFrame()
  if (ShockAndAwe.db.char.demoshoutshow) then
    ShockAndAwe:Print(L["config_DS_on"])
  else
    ShockAndAwe.frames["DemoShout"]:Hide()
    ShockAndAwe:Print(L["config_DS_off"]) end
  end

  function ShockAndAwe:ActivateIgnorePain()
    ShockAndAwe.db.char.ipshow = not ShockAndAwe.db.char.ipshow
    ShockAndAwe:CreateBaseFrame()
    if (ShockAndAwe.db.char.ipshow) then
      ShockAndAwe:Print(L["config_IP_on"])
    else
      ShockAndAwe.frames["IgnorePain"]:Hide()
      ShockAndAwe:Print(L["config_IP_off"])
    end
  end

  function ShockAndAwe:ActivateGCD()
    ShockAndAwe.db.char.gcdshow = not ShockAndAwe.db.char.gcdshow
    ShockAndAwe:CreateBaseFrame()
    if (ShockAndAwe.db.char.gcdshow) then
      ShockAndAwe.frames["GCD"]:Show()
      ShockAndAwe:Print(L["config_GCD_on"])
    else
      ShockAndAwe.frames["GCD"]:Hide()
      ShockAndAwe:Print(L["config_GCD_off"])
    end
  end

  function ShockAndAwe:ActivateMaelstrom()
    ShockAndAwe.db.char.maelstromshow = not ShockAndAwe.db.char.maelstromshow
    ShockAndAwe:CreateMaelstromFrame()
    if (ShockAndAwe.db.char.maelstromshow) then
      ShockAndAwe:MaelstromBar()
      ShockAndAwe:Print(L["config_MaelstromBar_on"])
    else
      ShockAndAwe.frames["Maelstrom"]:Hide()
      ShockAndAwe:Print(L["config_MaelstromBar_off"])
    end
  end

  function ShockAndAwe:ActivateGCDfullwidth()
    ShockAndAwe.db.char.gcdfullwidth = not ShockAndAwe.db.char.gcdfullwidth
    ShockAndAwe:SetTalentEffects()
    ShockAndAwe:CreateBaseFrame()
    if (ShockAndAwe.db.char.gcdfullwidth) then
      ShockAndAwe:Print(L["config_GCD_fullwidth_on"])
    else
      ShockAndAwe:Print(L["config_GCD_fullwidth_off"])
    end
  end

  function ShockAndAwe:Activatedisablebars()
    ShockAndAwe.db.char.disablebars = not ShockAndAwe.db.char.disablebars
    if (ShockAndAwe.db.char.disablebars) then
      if not InCombatLockdown() then
        if ShockAndAwe.db.char.maelstromshow then
          ShockAndAwe:MaelstromBar()
        else
          ShockAndAwe.BaseFrame:Hide()
        end
      end
      ShockAndAwe:Print(L["config_disable_on"])
    else
      ShockAndAwe.BaseFrame:Show()
      ShockAndAwe:Print(L["config_disable_off"])
    end
  end

  function ShockAndAwe:ActivateBarIcons()
    ShockAndAwe.db.char.showicons = not ShockAndAwe.db.char.showicons
    if (ShockAndAwe.db.char.showicons) then
      ShockAndAwe:Print(L["config_baricons_on"])
    else
      ShockAndAwe:Print(L["config_baricons_off"])
    end
  end

  function ShockAndAwe:ActivateDebug()
    ShockAndAwe.db.char.debug = not ShockAndAwe.db.char.debug
    if (ShockAndAwe.db.char.debug) then
      ShockAndAwe:Print(L["config_debug_on"])
    else
      ShockAndAwe:Print(L["config_debug_off"])
    end
  end

  function ShockAndAwe:Activatespecchangewarning()
    ShockAndAwe.db.char.specchangewarning = not ShockAndAwe.db.char.specchangewarning
    if (ShockAndAwe.db.char.specchangewarning) then
      ShockAndAwe:Print(L["config_specchangewarning_on"])
    else
      ShockAndAwe:Print(L["config_specchangewarning_off"])
    end
  end

  function ShockAndAwe:ActivateHeroicStrike()
    -- ShockAndAwe.db.char.hsshow = not ShockAndAwe.db.char.hsshow
    -- if (ShockAndAwe.db.char.hsshow) then
    -- ShockAndAwe:Print(L["config_HS_on"])
    -- else
    -- ShockAndAwe:Print(L["config_HS_off"])
    -- end
  end

  function ShockAndAwe:ActivateHideImmune()
    ShockAndAwe.db.char.priority.hideImmune = not ShockAndAwe.db.char.priority.hideImmune
    if (ShockAndAwe.db.char.priority.hideImmune) then
      ShockAndAwe:Print(L["config_hideimmune_on"])
    else
      ShockAndAwe:Print(L["config_hideimmune_off"])
    end
  end

  function ShockAndAwe:ActivateShowInterrupt()
    ShockAndAwe.db.char.priority.showinterrupt = not ShockAndAwe.db.char.priority.showinterrupt
    if (ShockAndAwe.db.char.priority.showinterrupt) then
      --ShockAndAwe.PriorityFrame.interrupt.frame:Show()
      ShockAndAwe:Print(L["config_showinterrupt_on"])
    else
      --ShockAndAwe.PriorityFrame.interrupt.frame:Hide()
      ShockAndAwe:Print(L["config_showinterrupt_off"])
    end
  end

  function ShockAndAwe:ActivateShowPurge()
    ShockAndAwe.db.char.hsshow = not ShockAndAwe.db.char.hsshow
    if (ShockAndAwe.db.char.hsshow) then
      ShockAndAwe.PriorityFrame.purge.frame:Show()
      ShockAndAwe:Print(L["config_showpurge_on"])
    else
      ShockAndAwe.PriorityFrame.purge.frame:Hide()
      ShockAndAwe:Print(L["config_showpurge_off"])
    end
  end

  function ShockAndAwe:ActivateShowCooldown()
    ShockAndAwe.db.char.priority.showcooldown = not ShockAndAwe.db.char.priority.showcooldown
    if (ShockAndAwe.db.char.priority.showcooldown) then
      ShockAndAwe:Print(L["config_showcooldown_on"])
    else
      ShockAndAwe:Print(L["config_showcooldown_off"])
    end
  end

  function ShockAndAwe:ActivateTextOnBars()
    ShockAndAwe.db.char.barstext = not ShockAndAwe.db.char.barstext
    if (ShockAndAwe.db.char.barstext) then
      ShockAndAwe:Print(L["config_Barstext_on"])
    else
      ShockAndAwe:Print(L["config_Barstext_off"])
    end
  end

  function ShockAndAwe:ActivateEnableTimeRemaining()
    ShockAndAwe.db.char.enableTimeRemaining = not ShockAndAwe.db.char.enableTimeRemaining
    if (ShockAndAwe.db.char.enableTimeRemaining) then
      ShockAndAwe:Print(L["config_enableTimeRemaining_on"])
    else
      ShockAndAwe:Print(L["config_enableTimeRemaining_off"])
    end
  end

  function ShockAndAwe:ActivateHideMaelstromBarOOC()
    ShockAndAwe.db.char.hideMaelstromBarOOC = not ShockAndAwe.db.char.hideMaelstromBarOOC
    if (ShockAndAwe.db.char.hideMaelstromBarOOC) then
      ShockAndAwe:Print(L["config_hideMaelstromBarOOC_on"])
      ShockAndAwe:MaelstromBar()
    else
      ShockAndAwe:Print(L["config_hideMaelstromBarOOC_off"])
      ShockAndAwe:MaelstromBar()
    end
  end

  function ShockAndAwe:ActivateRestoSpec()
    local currentSpec = GetSpecialization()
    ShockAndAwe.db.char.enableRestoSpec = not ShockAndAwe.db.char.enableRestoSpec
    if (ShockAndAwe.db.char.enableRestoSpec) then
      ShockAndAwe:Print(L["config_enableRestoSpec_on"])
      if ShockAndAwe.db.char.disabled and currentSpec == 3 then
        ShockAndAwe:Enable()
      end
    else
      ShockAndAwe:Print(L["config_enableRestoSpec_off"])
      if ShockAndAwe.db.char.disabled == false and currentSpec == 3 then
        ShockAndAwe:Disable()
      end
    end
  end

  function ShockAndAwe:ActivateEnhancementSpec()
    local currentSpec = GetSpecialization()
    ShockAndAwe.db.char.enableEnhancementSpec = not ShockAndAwe.db.char.enableEnhancementSpec
    if (ShockAndAwe.db.char.enableEnhancementSpec) then
      ShockAndAwe:Print(L["config_enableEnhancementSpec_on"])
      if ShockAndAwe.db.char.disabled and currentSpec == 2 then
        ShockAndAwe:Enable()
      end
    else
      ShockAndAwe:Print(L["config_enableEnhancementSpec_off"])
      if ShockAndAwe.db.char.disabled == false and currentSpec == 2 then
        ShockAndAwe:Disable()
      end
    end
  end

  function ShockAndAwe:ActivateElementalSpec()
    local currentSpec = GetSpecialization()
    ShockAndAwe.db.char.enableElementalSpec = not ShockAndAwe.db.char.enableElementalSpec
    if (ShockAndAwe.db.char.enableElementalSpec) then
      ShockAndAwe:Print(L["config_enableElementalSpec_on"])
      if ShockAndAwe.db.char.disabled and currentSpec == 1 then
        ShockAndAwe:Enable()
      end
    else
      ShockAndAwe:Print(L["config_enableElementalSpec_off"])
      if not ShockAndAwe.db.char.disabled and currentSpec == 1 then
        ShockAndAwe:Disable()
      end
    end
  end

  function ShockAndAwe:ShowHideBars()
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot move frames in combat"])
      return
    end
    ShockAndAwe.db.char.movingframes = not ShockAndAwe.db.char.movingframes
    if ShockAndAwe.db.char.movingframes then
      ShockAndAwe.PriorityFrame:EnableMouse(1)
      ShockAndAwe.PriorityFrame:SetBackdropColor(0, 0, 0, 1)
      ShockAndAwe.PriorityFrame:Show()
      ShockAndAwe.UptimeFrame:EnableMouse(1)
      ShockAndAwe.UptimeFrame:SetBackdropColor(0, 0, 0, 1)
      ShockAndAwe.UptimeFrame:Show()
      ShockAndAwe.msgFrame:EnableMouse(1)
      ShockAndAwe.msgFrame:SetBackdropColor(0, 0, 0, 1)
      ShockAndAwe.msgFrame:Show()
      ShockAndAwe.BaseFrame:EnableMouse(1)
      ShockAndAwe.BaseFrame:SetBackdropColor(0, 0, 0, 1);
      ShockAndAwe.frames["GCD"]:Show()
      ShockAndAwe.UptimeFrame:Show()
      ShockAndAwe.MaelstromFrame:EnableMouse(1)
      ShockAndAwe.MaelstromFrame:SetBackdropColor(0, 0, 0, 1)
      ShockAndAwe.MaelstromFrame:Show()
      ShockAndAwe:MaelstromBar()

      -- All specs have these
--[[
      ShockAndAwe:BattleCryBar()
      if ShockAndAwe.db.char.talBloodbath then
        ShockAndAwe:BloodbathBar()
      end
      if ShockAndAwe.db.char.talAvatar then
        ShockAndAwe:AvatarBar()
      end
      if ShockAndAwe.db.char.currentspec == "Enhancement" then
        ShockAndAwe:CommandingShoutBar()
        if ShockAndAwe.db.char.talDragonRoar then
          ShockAndAwe:DragonRoarBar()
        end
      elseif ShockAndAwe.db.char.currentspec == "Restoration" then
        -- ShockAndAwe:IgnorePainBar() -- Don't show this since it isn't timer based and will get stuck.
        ShockAndAwe:ShieldBlockBar()
        ShockAndAwe:ShieldWallBar()
        ShockAndAwe:DemoShoutBar()
        ShockAndAwe:LastStandBar()
      elseif ShockAndAwe.db.char.currentspec == "Elemental" then
        ShockAndAwe:ColossusSmashBar()
        ShockAndAwe:CommandingShoutBar()
      end
--]]
    else
      ShockAndAwe.PriorityFrame:EnableMouse(false);
      ShockAndAwe.PriorityFrame:SetBackdropColor(1, 1, 1, 0);
      ShockAndAwe.BaseFrame:EnableMouse(false);
      ShockAndAwe.BaseFrame:SetBackdropColor(1, 1, 1, 0);
      ShockAndAwe.UptimeFrame:EnableMouse(false)
      ShockAndAwe.UptimeFrame:SetBackdropColor(0, 0, 0, 0.3);
      ShockAndAwe.msgFrame:EnableMouse(false)
      ShockAndAwe.msgFrame:SetBackdropColor(1, 1, 1, 0);
      ShockAndAwe.MaelstromFrame:EnableMouse(false)
      ShockAndAwe.MaelstromFrame:SetBackdropColor(1, 1, 1, 0);
      -- ShockAndAwe.BaseFrame:Hide()
      ShockAndAwe.frames["GCD"]:Hide()
      if ShockAndAwe.db.char.priority.show and InCombatLockdown() then
        ShockAndAwe.PriorityFrame:Show()
      else
        ShockAndAwe.PriorityFrame:Hide()
      end
      if ShockAndAwe.db.char.uptime.show and not ShockAndAwe.db.char.disabled then
        ShockAndAwe.UptimeFrame:Show()
      else
        ShockAndAwe.UptimeFrame:Hide()
      end

      ShockAndAwe:MaelstromBar()
    end
    ShockAndAwe:SetPriorityUpdateScript()
  end

  function ShockAndAwe:FinishedMoving(var, frame)
    local point, relativeTo, relativePoint, xOffset, yOffset = frame:GetPoint();
    var.point = point
    var.relativeTo = relativeTo
    var.relativePoint = relativePoint
    var.xOffset = xOffset
    var.yOffset = yOffset
  end

  function ShockAndAwe:MovingFramesQuery()
    return ShockAndAwe.db.char.movingframes
  end

  function ShockAndAwe:enableRestoSpecQuery()
    return ShockAndAwe.db.char.enableRestoSpec
  end

  function ShockAndAwe:enableEnhancementSpecQuery()
    return ShockAndAwe.db.char.enableEnhancementSpec
  end

  function ShockAndAwe:enableElementalSpecQuery()
    return ShockAndAwe.db.char.enableElementalSpec
  end

  function ShockAndAwe:PetFrameQuery()
    return ShockAndAwe.db.char.petframeshow
  end

  function ShockAndAwe:SSQuery()
    return ShockAndAwe.db.char.ssshow
  end

  function ShockAndAwe:FireTotemQuery()
    return ShockAndAwe.db.char.firetotemshow
  end

  function ShockAndAwe:WFQuery()
    return ShockAndAwe.db.char.wfshow
  end

  function ShockAndAwe:shockQuery()
    return ShockAndAwe.db.char.shockshow
  end

  function ShockAndAwe:fsdotbarQuery()
    return ShockAndAwe.db.char.fsdotshow
  end

  function ShockAndAwe:shearQuery()
    return ShockAndAwe.db.char.shearshow
  end

  function ShockAndAwe:gcdQuery()
    return ShockAndAwe.db.char.gcdshow
  end

  function ShockAndAwe:gcdFullwidthQuery()
    return ShockAndAwe.db.char.gcdfullwidth
  end

  function ShockAndAwe:heroicstrikeQuery()
    return ShockAndAwe.db.char.hsshow
  end

  --function ShockAndAwe:combopointsQuery()
  -- return ShockAndAwe.db.char.priority.combopoints
  --end

  function ShockAndAwe:worldbossQuery()
    return ShockAndAwe.db.char.priority.worldbossonly
  end

  function ShockAndAwe:hideImmuneQuery()
    return ShockAndAwe.db.char.priority.hideImmune
  end

  function ShockAndAwe:showinterruptQuery()
    return ShockAndAwe.db.char.priority.showinterrupt
  end

  function ShockAndAwe:showpurgeQuery()
    return ShockAndAwe.db.char.hsshow
  end

  function ShockAndAwe:showcooldownQuery()
    return ShockAndAwe.db.char.priority.showcooldown
  end

  function ShockAndAwe:disablebarsQuery()
    return ShockAndAwe.db.char.disablebars
  end

  function ShockAndAwe:bariconsQuery()
    return ShockAndAwe.db.char.showicons
  end

  function ShockAndAwe:arenaQuery()
    return ShockAndAwe.db.char.arena
  end

  function ShockAndAwe:showUptimeQuery()
    return ShockAndAwe.db.char.uptime.show
  end

  function ShockAndAwe:tfbQuery()
    return ShockAndAwe.db.char.tfbshow
  end

  --ShockAndAwe
  function ShockAndAwe:ignorepainQuery()
    return ShockAndAwe.db.char.ipshow
  end

  function ShockAndAwe:shieldblockQuery()
    return ShockAndAwe.db.char.sblshow
  end

  function ShockAndAwe:shieldwallQuery()
    return ShockAndAwe.db.char.swshow
  end

  function ShockAndAwe:lastStandQuery()
    return ShockAndAwe.db.char.laststandshow
  end

  function ShockAndAwe:commandingShoutQuery()
    return ShockAndAwe.db.char.commandingshoutshow
  end

  function ShockAndAwe:demoShoutQuery()
    return ShockAndAwe.db.char.demoshoutshow
  end

  function ShockAndAwe:enableTimeRemainingQuery()
    return ShockAndAwe.db.char.enableTimeRemaining
  end

  function ShockAndAwe:hideMaelstromBarOOCQuery()
    return ShockAndAwe.db.char.hideMaelstromBarOOC
  end

  function ShockAndAwe:colossussmashQuery()
    return ShockAndAwe.db.char.csshow
  end

  function ShockAndAwe:dragonroarQuery()
    return ShockAndAwe.db.char.drshow
  end

  function ShockAndAwe:avatarQuery()
    return ShockAndAwe.db.char.avashow
  end

  function ShockAndAwe:battlecryQuery()
    return ShockAndAwe.db.char.bcshow
  end

  function ShockAndAwe:bloodbathQuery()
    return ShockAndAwe.db.char.bbshow
  end

  function ShockAndAwe:maelstrombarQuery()
    return ShockAndAwe.db.char.maelstromshow
  end

  function ShockAndAwe:firenovaQuery()
    return ShockAndAwe.db.char.fnshow
  end

  function ShockAndAwe:textOnBarsQuery()
    return ShockAndAwe.db.char.barstext
  end

  function ShockAndAwe:mw5soundplayQuery()
    return ShockAndAwe.db.char.mw5soundplay
  end

  function ShockAndAwe:mw4soundplayQuery()
    return ShockAndAwe.db.char.mw4soundplay
  end

  function ShockAndAwe:mw5flashQuery()
    return ShockAndAwe.db.char.mw5flash
  end

  function ShockAndAwe:debugQuery()
    return ShockAndAwe.db.char.debug
  end

  function ShockAndAwe:specchangewarningQuery()
    return ShockAndAwe.db.char.specchangewarning
  end

  function ShockAndAwe:GetBarTexture()
    return ShockAndAwe.db.char.texture
  end

  function ShockAndAwe:GetMaelstromBarTexture()
    return ShockAndAwe.db.char.maelstrombar.texture
  end

  function ShockAndAwe:GetBorderTexture()
    return ShockAndAwe.db.char.border
  end

  function ShockAndAwe:GetBarBorderTexture()
    return ShockAndAwe.db.char.barborder
  end

  function ShockAndAwe:GetPriorityBorderTexture()
    return ShockAndAwe.db.char.priority.barborder
  end

  function ShockAndAwe:GetMaelstromBarBorderTexture()
    return ShockAndAwe.db.char.maelstrombar.barborder
  end

  function ShockAndAwe:GetBarFont()
    return ShockAndAwe.db.char.barfont
  end

  function ShockAndAwe:GetMaelstromBarFont()
    return ShockAndAwe.db.char.maelstrombar.barfont
  end

  function ShockAndAwe:GetBarFontSize()
    return ShockAndAwe.db.char.barfontsize
  end

  function ShockAndAwe:GetMaelstromBarFontSize()
    return ShockAndAwe.db.char.maelstrombar.barfontsize
  end

  function ShockAndAwe:GetBarFontEffect()
    return ShockAndAwe.db.char.barfonteffect
  end

  function ShockAndAwe:GetMaelstromBarFontEffect()
    return ShockAndAwe.db.char.maelstrombar.barfonteffect
  end

  function ShockAndAwe:GetMsgFont()
    return ShockAndAwe.db.char.msgfont
  end

  function ShockAndAwe:GetMsgFontSize()
    return ShockAndAwe.db.char.msgfontsize
  end

  function ShockAndAwe:GetMsgFontEffect()
    return ShockAndAwe.db.char.msgfonteffect
  end

  function ShockAndAwe:GetWidth()
    return ShockAndAwe.db.char.fWidth
  end

  function ShockAndAwe:GetHeight()
    return ShockAndAwe.db.char.fHeight
  end

  function ShockAndAwe:GetScale()
    return ShockAndAwe.db.char.scale
  end

  function ShockAndAwe:GetMaelstromBarWidth()
    return ShockAndAwe.db.char.maelstrombar.fWidth
  end

  function ShockAndAwe:GetMaelstromBarHeight()
    return ShockAndAwe.db.char.maelstrombar.fHeight
  end

  function ShockAndAwe:GetMaelstromBarScale()
    return ShockAndAwe.db.char.maelstrombar.scale
  end

  function ShockAndAwe:GetPriorityScale()
    return ShockAndAwe.db.char.priority.scale
  end

  function ShockAndAwe:GetTFBalpha()
    return ShockAndAwe.db.char.colors.tfbalpha
  end

  function ShockAndAwe:GetTFBalphaFull()
    return ShockAndAwe.db.char.colors.tfbalphaFull
  end

  function ShockAndAwe:GetWeaponSound()
    return ShockAndAwe.db.char.weaponsoundname
  end

  function ShockAndAwe:Gettfb5sound()
    return ShockAndAwe.db.char.tfb5soundname
  end

  function ShockAndAwe:Gettfb5repeat()
    return ShockAndAwe.db.char.tfb5repeat
  end

  function ShockAndAwe:Gettfb4sound()
    return ShockAndAwe.db.char.tfb4soundname
  end

  function ShockAndAwe:GetThreatThreshold()
    return ShockAndAwe.db.char.threatThreshold
  end

  function ShockAndAwe:GetMaelstromThreshold()
    return ShockAndAwe.db.char.maelstromThreshold
  end

  function ShockAndAwe:GetCooldownThreshold()
    return ShockAndAwe.db.char.priority.cooldown
  end

  function ShockAndAwe:GetTotemTimeLeft()
    return ShockAndAwe.db.char.priority.totemtimeleft
  end

  function ShockAndAwe:GetRebuffTime()
    return ShockAndAwe.db.char.warning.timeleft
  end

  function ShockAndAwe:GetShowWFTotals()
    return ShockAndAwe.db.char.stats.wfcalc
  end

  function ShockAndAwe:SetBarFont(info, newValue)
    ShockAndAwe.db.char.barfont = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetMaelstromBarFont(info, newValue)
    ShockAndAwe.db.char.maelstrombar.barfont = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetBarFontSize(info, newValue)
    ShockAndAwe.db.char.barfontsize = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetMaelstromBarFontSize(info, newValue)
    ShockAndAwe.db.char.maelstrombar.barfontsize = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetBarFontEffect(info, newValue)
    ShockAndAwe.db.char.barfonteffect = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetMaelstromBarFontEffect(info, newValue)
    ShockAndAwe.db.char.maelstrombar.barfonteffect = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:SetMsgFont(info, newValue)
    ShockAndAwe.db.char.msgfont = newValue
    ShockAndAwe:CreateMsgFrame()
    ShockAndAwe:PrintMsg("Out Of Range", ShockAndAwe.db.char.warning.color)
  end

  function ShockAndAwe:SetMsgFontSize(info, newValue)
    ShockAndAwe.db.char.msgfontsize = newValue
    ShockAndAwe:CreateMsgFrame()
    ShockAndAwe:PrintMsg("Out Of Range", ShockAndAwe.db.char.warning.color)
  end

  function ShockAndAwe:SetMsgFontEffect(info, newValue)
    ShockAndAwe.db.char.msgfonteffect = newValue
    ShockAndAwe:CreateMsgFrame()
    ShockAndAwe:PrintMsg("Out Of Range", ShockAndAwe.db.char.warning.color)
  end

  function ShockAndAwe:SetBarTexture(info, newValue)
    ShockAndAwe.db.char.texture = newValue
    local barTexture = media:Fetch('statusbar', newValue)
    ShockAndAwe.frames["GCD"].statusbar:SetStatusBarTexture(barTexture)
    ShockAndAwe:RedrawFrames()
  end

  function ShockAndAwe:SetMaelstromBarTexture(info, newValue)
    ShockAndAwe.db.char.maelstrombar.texture = newValue
    local barTexture = media:Fetch('statusbar', newValue)
    ShockAndAwe.frames["GCD"].statusbar:SetStatusBarTexture(barTexture)
    ShockAndAwe:RedrawFrames()
  end

  function ShockAndAwe:SetBorderTexture(info, newValue)
    ShockAndAwe.db.char.border = newValue
    local newTexture = media:Fetch("border", ShockAndAwe.db.char.border)
    if newTexture then
      ShockAndAwe.frameBackdrop.edgeFile = newTexture
      ShockAndAwe:RedrawFrames()
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("border texture not found. Trying to set "..ShockAndAwe.db.char.border)
      end
    end
  end

  function ShockAndAwe:SetBarBorderTexture(info, newValue)
    ShockAndAwe.db.char.barborder = newValue
    local newTexture = media:Fetch("border", ShockAndAwe.db.char.barborder)
    if newTexture then
      ShockAndAwe.barBackdrop.edgeFile = newTexture
      ShockAndAwe.frames["GCD"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["IgnorePain"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldBlock"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldWall"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ColossusSmash"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["BattleCry"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Bloodbath"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Avatar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DragonRoar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DemoShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["LastStand"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["CommandingShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe:RedrawFrames()
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("bar border texture not found. Trying to set "..ShockAndAwe.db.char.barborder)
      end
    end
  end

  function ShockAndAwe:SetPriorityBorderTexture(info, newValue)
    ShockAndAwe.db.char.priority.barborder = newValue
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.debug then
      ShockAndAwe:Print("bar border texture not found. Trying to set "..ShockAndAwe.db.char.priority.barborder)
    end
  end

  function ShockAndAwe:SetMaelstromBarBorderTexture(info, newValue)
    ShockAndAwe.db.char.maelstrombar.barborder = newValue
    local newTexture = media:Fetch("border", ShockAndAwe.db.char.maelstrombar.barborder)
    if newTexture then
      ShockAndAwe.maelstrombarBackdrop.edgeFile = newTexture
      ShockAndAwe.frames["Maelstrom"]:SetBackdrop(ShockAndAwe.maelstrombarBackdrop)
      ShockAndAwe:RedrawFrames()
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("bar border texture not found. Trying to set "..ShockAndAwe.db.char.maelstrombar.barborder)
      end
    end
  end

  function ShockAndAwe:SetWeaponSound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    ShockAndAwe.db.char.weaponsoundname = newValue
    if newSound then
      ShockAndAwe.db.char.weaponsound = newSound
      PlaySoundFile(newSound)
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function ShockAndAwe:SetMW5sound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    ShockAndAwe.db.char.mw5soundname = newValue
    if newSound then
      ShockAndAwe.db.char.mw5sound = newSound
      PlaySoundFile(newSound)
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function ShockAndAwe:SetMW5repeat(info, newValue)
    ShockAndAwe.db.char.mw5repeat = newValue
  end

  function ShockAndAwe:SetMW4sound(info, newValue)
    local newSound = media:Fetch("sound", newValue)
    ShockAndAwe.db.char.mw4soundname = newValue
    if newSound then
      ShockAndAwe.db.char.mw4sound = newSound
      PlaySoundFile(newSound)
    else
      if ShockAndAwe.db.char.debug then
        ShockAndAwe:Print("Sound not found. Trying to set "..newSound)
      end
    end
  end

  function ShockAndAwe:SetThreatThreshold(info, newValue)
    ShockAndAwe.db.char.threatThreshold = newValue
    ShockAndAwe:Print(L["config_Threat"]..newValue)
  end

  function ShockAndAwe:SetMaelstromThreshold(info, newValue)
    ShockAndAwe.db.char.maelstromThreshold = newValue
    ShockAndAwe:Print(L["config_Maelstrom"]..newValue)
  end

  function ShockAndAwe:SetCooldownThreshold(info, newValue)
    ShockAndAwe.db.char.priority.cooldown = newValue
    ShockAndAwe:Print(L["config_Cooldown"]..newValue)
  end

  function ShockAndAwe:SetRebuffTime(info, newValue)
    ShockAndAwe.db.char.warning.timeleft = newValue
  end

  function ShockAndAwe:SetWidth(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change bar width in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.fWidth = newValue
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:DebugPrint(L["Frame width set to : "]..ShockAndAwe.db.char.fWidth)
  end

  function ShockAndAwe:SetMaelstromBarWidth(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change bar width in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.maelstrombar.fWidth = newValue
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:DebugPrint(L["Frame width set to : "]..ShockAndAwe.db.char.maelstrombar.fWidth)
  end

  function ShockAndAwe:SetHeight(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change bar height in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.fHeight = newValue
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:DebugPrint(L["Frame height set to : "]..ShockAndAwe.db.char.fHeight)
  end

  function ShockAndAwe:SetMaelstromBarHeight(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change bar height in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.maelstrombar.fHeight = newValue
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:DebugPrint(L["Frame height set to : "]..ShockAndAwe.db.char.maelstrombar.fHeight)
  end

  function ShockAndAwe:SetScale(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change scale in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.scale = newValue
    ShockAndAwe.BaseFrame:SetScale(ShockAndAwe.db.char.scale)
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    ShockAndAwe:DebugPrint(L["Scale set to : "]..ShockAndAwe.db.char.scale)
  end

  function ShockAndAwe:SetMaelstromBarScale(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change scale in combat"])
      return
    end
    local wasMoving = ShockAndAwe.db.char.movingframes
    ShockAndAwe.db.char.maelstrombar.scale = newValue
    ShockAndAwe.MaelstromFrame:SetScale(ShockAndAwe.db.char.maelstrombar.scale)
    if wasMoving then
      ShockAndAwe:ShowHideBars()
    end
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.maelstromshow then
      ShockAndAwe:MaelstromBar()
    end
    ShockAndAwe:DebugPrint(L["Scale set to : "]..ShockAndAwe.db.char.maelstrombar.scale)
  end

  function ShockAndAwe:SetPriorityScale(info,newValue)
    if InCombatLockdown() then
      ShockAndAwe:Print(L["Cannot change scale in combat"])
    end
    ShockAndAwe.db.char.priority.scale = newValue
    ShockAndAwe.PriorityFrame:SetScale(ShockAndAwe.db.char.priority.scale)
    ShockAndAwe:DebugPrint(L["Priority Scale set to : "]..ShockAndAwe.db.char.priority.scale)
  end

  function ShockAndAwe:SetTFBalpha(info,newValue)
    if ShockAndAwe.db.char.tfbshow then
      ShockAndAwe.db.char.colors.tfbalpha = newValue
      ShockAndAwe:Print(L["config_tfbAlpha_ooc"]..ShockAndAwe.db.char.colors.tfbalpha)
      ShockAndAwe:SetTasteForBloodAlpha(ShockAndAwe.db.char.colors.tfbalpha)
    end
  end

  function ShockAndAwe:SetTFBalphaFull(info,newValue)
    if ShockAndAwe.db.char.tfbshow then
      ShockAndAwe.db.char.colors.tfbalphaFull = newValue
      ShockAndAwe:Print(L["config_tfbAlpha_combat"]..ShockAndAwe.db.char.colors.tfbalphaFull)
      ShockAndAwe:SetTasteForBloodAlpha(ShockAndAwe.db.char.colors.tfbalphaFull)
    end
  end

  function ShockAndAwe:SetTasteForBloodAlpha(alphaValue)
    ShockAndAwe.frames["TasteForBlood"]:SetBackdropColor(0, 0, 0, alphaValue * .2)
    ShockAndAwe.frames["TasteForBlood"]:SetBackdropBorderColor( 1, 1, 1, alphaValue)
    local colors = ShockAndAwe.db.char.colors.tfb
    ShockAndAwe.frames["TasteForBlood"].statusbar:SetStatusBarColor( colors.r, colors.g, colors.b, alphaValue)
  end

  -----------------------------------------
  -- Color choices getter/setters
  -----------------------------------------

  function ShockAndAwe:getFlameShockColor(info)
    local colors = ShockAndAwe.db.char.colors.flameshock
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setFlameShockColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.flameshock.r = r
    ShockAndAwe.db.char.colors.flameshock.g = g
    ShockAndAwe.db.char.colors.flameshock.b = b
    ShockAndAwe.db.char.colors.flameshock.a = a
    ShockAndAwe:ShockBar(ShockAndAwe.db.char.colors.flameshock)
  end

  function ShockAndAwe:getFlameShockDotColor(info)
    local colors = ShockAndAwe.db.char.colors.flameshockDot
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setFlameShockDotColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.flameshockDot.r = r
    ShockAndAwe.db.char.colors.flameshockDot.g = g
    ShockAndAwe.db.char.colors.flameshockDot.b = b
    ShockAndAwe.db.char.colors.flameshockDot.a = a
    FSDotTime = GetTime() + 18
    ShockAndAwe:FlameShockDotBar(true)
  end

  function ShockAndAwe:getFrostShockColor(info)
    local colors = ShockAndAwe.db.char.colors.frostshock
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setFrostShockColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.frostshock.r = r
    ShockAndAwe.db.char.colors.frostshock.g = g
    ShockAndAwe.db.char.colors.frostshock.b = b
    ShockAndAwe.db.char.colors.frostshock.a = a
    ShockAndAwe:ShockBar(ShockAndAwe.db.char.colors.frostshock)
  end

  function ShockAndAwe:getWindShearColor(info)
    local colors = ShockAndAwe.db.char.colors.windshear
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setWindShearColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.windshear.r = r
    ShockAndAwe.db.char.colors.windshear.g = g
    ShockAndAwe.db.char.colors.windshear.b = b
    ShockAndAwe.db.char.colors.windshear.a = a
    ShockAndAwe:ShearBar()
  end

  function ShockAndAwe:getTasteForBloodColor(info)
    local colors = ShockAndAwe.db.char.colors.tfb
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setTasteForBloodColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.tfb.r = r
    ShockAndAwe.db.char.colors.tfb.g = g
    ShockAndAwe.db.char.colors.tfb.b = b
    ShockAndAwe.db.char.colors.tfb.a = a
  end

  function ShockAndAwe:getStormstrikeColor(info)
    local colors = ShockAndAwe.db.char.colors.stormstrike
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setStormstrikeColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.stormstrike.r = r
    ShockAndAwe.db.char.colors.stormstrike.g = g
    ShockAndAwe.db.char.colors.stormstrike.b = b
    ShockAndAwe.db.char.colors.stormstrike.a = a
    ShockAndAwe:StormstrikeBar()
  end

  function ShockAndAwe:getDemoShoutColor(info)
    local colors = ShockAndAwe.db.char.colors.demoshout
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setDemoShoutColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.demoshout.r = r
    ShockAndAwe.db.char.colors.demoshout.g = g
    ShockAndAwe.db.char.colors.demoshout.b = b
    ShockAndAwe.db.char.colors.demoshout.a = a
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.currentspec == "Restoration" then
      ShockAndAwe:DemoShoutBar()
    end
  end

  function ShockAndAwe:getLastStandColor(info)
    local colors = ShockAndAwe.db.char.colors.laststand
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setLastStandColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.laststand.r = r
    ShockAndAwe.db.char.colors.laststand.g = g
    ShockAndAwe.db.char.colors.laststand.b = b
    ShockAndAwe.db.char.colors.laststand.a = a
    ShockAndAwe:RedrawFrames()
    if ShockAndAwe.db.char.currentspec == "Restoration" then
      ShockAndAwe:LastStandBar()
    end
  end

  function ShockAndAwe:getWindfuryColor(info)
    local colors = ShockAndAwe.db.char.colors.windfury
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setWindfuryColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.windfury.r = r
    ShockAndAwe.db.char.colors.windfury.g = g
    ShockAndAwe.db.char.colors.windfury.b = b
    ShockAndAwe.db.char.colors.windfury.a = a
    ShockAndAwe:WFProcBar()
  end

  function ShockAndAwe:getIgnorePainColor(info)
    local colors = ShockAndAwe.db.char.colors.ignorepain
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setIgnorePainColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.ignorepain.r = r
    ShockAndAwe.db.char.colors.ignorepain.g = g
    ShockAndAwe.db.char.colors.ignorepain.b = b
    ShockAndAwe.db.char.colors.ignorepain.a = a
  end

  function ShockAndAwe:getShieldBlockColor(info)
    local colors = ShockAndAwe.db.char.colors.shieldblock
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setShieldBlockColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.shieldblock.r = r
    ShockAndAwe.db.char.colors.shieldblock.g = g
    ShockAndAwe.db.char.colors.shieldblock.b = b
    ShockAndAwe.db.char.colors.shieldblock.a = a
    if ShockAndAwe.db.char.currentspec == "Restoration" then
      ShockAndAwe:ShieldBlockBar()
    end
  end

  function ShockAndAwe:getShieldWallColor(info)
    local colors = ShockAndAwe.db.char.colors.shieldwall
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setShieldWallColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.shieldwall.r = r
    ShockAndAwe.db.char.colors.shieldwall.g = g
    ShockAndAwe.db.char.colors.shieldwall.b = b
    ShockAndAwe.db.char.colors.shieldwall.a = a
    if ShockAndAwe.db.char.currentspec == "Restoration" then
      ShockAndAwe:ShieldWallBar()
    end
  end

  function ShockAndAwe:getMaelstromColor(info)
    local colors = ShockAndAwe.db.char.colors.maelstrom
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:getSixtyMaelstromColor(info)
    local colors = ShockAndAwe.db.char.colors.sixtymaelstrom
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:getCommandingShoutColor(info)
    local colors = ShockAndAwe.db.char.colors.commandingshout
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setCommandingShoutColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.commandingshout.r = r
    ShockAndAwe.db.char.colors.commandingshout.g = g
    ShockAndAwe.db.char.colors.commandingshout.b = b
    ShockAndAwe.db.char.colors.commandingshout.a = a
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:CommandingShoutBar()
  end

  function ShockAndAwe:setMaelstromColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.maelstrom.r = r
    ShockAndAwe.db.char.colors.maelstrom.g = g
    ShockAndAwe.db.char.colors.maelstrom.b = b
    ShockAndAwe.db.char.colors.maelstrom.a = a
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:setSixtyMaelstromColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.sixtymaelstrom.r = r
    ShockAndAwe.db.char.colors.sixtymaelstrom.g = g
    ShockAndAwe.db.char.colors.sixtymaelstrom.b = b
    ShockAndAwe.db.char.colors.sixtymaelstrom.a = a
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:MaelstromBar()
  end

  function ShockAndAwe:getTasteForBloodColor(info)
    local colors = ShockAndAwe.db.char.colors.tfb
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setTasteForBloodColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.tfb.r = r
    ShockAndAwe.db.char.colors.tfb.g = g
    ShockAndAwe.db.char.colors.tfb.b = b
    ShockAndAwe.db.char.colors.tfb.a = a
  end

  function ShockAndAwe:getColossusSmashColor(info)
    local colors = ShockAndAwe.db.char.colors.colossussmash
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setColossusSmashColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.colossussmash.r = r
    ShockAndAwe.db.char.colors.colossussmash.g = g
    ShockAndAwe.db.char.colors.colossussmash.b = b
    ShockAndAwe.db.char.colors.colossussmash.a = a
    if ShockAndAwe.db.char.currentspec == "Elemental" then
      ShockAndAwe:ColossusSmashBar()
    end
  end

  function ShockAndAwe:getAvatarColor(info)
    local colors = ShockAndAwe.db.char.colors.avatar
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setAvatarColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.avatar.r = r
    ShockAndAwe.db.char.colors.avatar.g = g
    ShockAndAwe.db.char.colors.avatar.b = b
    ShockAndAwe.db.char.colors.avatar.a = a
    if ShockAndAwe.db.char.talAvatar then
      ShockAndAwe:AvatarBar()
    end
  end

  function ShockAndAwe:getDragonRoarColor(info)
    local colors = ShockAndAwe.db.char.colors.dragonroar
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setDragonRoarColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.dragonroar.r = r
    ShockAndAwe.db.char.colors.dragonroar.g = g
    ShockAndAwe.db.char.colors.dragonroar.b = b
    ShockAndAwe.db.char.colors.dragonroar.a = a
    if ShockAndAwe.db.char.talDragonRoar then
      ShockAndAwe:DragonRoarBar()
    end
  end

  function ShockAndAwe:getBattleCryColor(info)
    local colors = ShockAndAwe.db.char.colors.battlecry
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setBattleCryColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.battlecry.r = r
    ShockAndAwe.db.char.colors.battlecry.g = g
    ShockAndAwe.db.char.colors.battlecry.b = b
    ShockAndAwe.db.char.colors.battlecry.a = a
    ShockAndAwe:BattleCryBar()
  end

  function ShockAndAwe:getBloodbathColor(info)
    local colors = ShockAndAwe.db.char.colors.bloodbath
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setBloodbathColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.bloodbath.r = r
    ShockAndAwe.db.char.colors.bloodbath.g = g
    ShockAndAwe.db.char.colors.bloodbath.b = b
    ShockAndAwe.db.char.colors.bloodbath.a = a
    ShockAndAwe:BloodbathBar()
  end

  function ShockAndAwe:getFireNovaColor(info)
    local colors = ShockAndAwe.db.char.colors.firenova
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setFireNovaColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.firenova.r = r
    ShockAndAwe.db.char.colors.firenova.g = g
    ShockAndAwe.db.char.colors.firenova.b = b
    ShockAndAwe.db.char.colors.firenova.a = a
    ShockAndAwe:FireNovaBar()
  end

  function ShockAndAwe:getMagmaColor(info)
    local colors = ShockAndAwe.db.char.colors.magma
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setMagmaColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.magma.r = r
    ShockAndAwe.db.char.colors.magma.g = g
    ShockAndAwe.db.char.colors.magma.b = b
    ShockAndAwe.db.char.colors.magma.a = a
    ShockAndAwe:MagmaBar()
  end

  function ShockAndAwe:getLavaBurstColor(info)
    local colors = ShockAndAwe.db.char.colors.lavaburst
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setLavaBurstColor(info,r,g,b,a)
    ShockAndAwe.db.char.colors.lavaburst.r = r
    ShockAndAwe.db.char.colors.lavaburst.g = g
    ShockAndAwe.db.char.colors.lavaburst.b = b
    ShockAndAwe.db.char.colors.lavaburst.a = a
    ShockAndAwe:LavaBurstBar()
  end

  function ShockAndAwe:getIPColor(info)
    local colors = ShockAndAwe.db.char.uptime.ip
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function ShockAndAwe:setIPColor(info,r,g,b,a)
    ShockAndAwe.db.char.uptime.ip.r = r
    ShockAndAwe.db.char.uptime.ip.g = g
    ShockAndAwe.db.char.uptime.ip.b = b
    ShockAndAwe.db.char.uptime.ip.a = a
    local buffColors = ShockAndAwe.db.char.uptime.ip
    ShockAndAwe.uptime.session.buffs[GetSpellInfo(ShockAndAwe.constants["Ignore Pain ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    ShockAndAwe.uptime.lastfight.buffs[GetSpellInfo(ShockAndAwe.constants["Ignore Pain ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end
  --
  function ShockAndAwe:getSLColor(info)
    local colors = ShockAndAwe.db.char.uptime.sl
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function ShockAndAwe:setSLColor(info,r,g,b,a)
    ShockAndAwe.db.char.uptime.sl.r = r
    ShockAndAwe.db.char.uptime.sl.g = g
    ShockAndAwe.db.char.uptime.sl.b = b
    ShockAndAwe.db.char.uptime.sl.a = a
    local buffColors = ShockAndAwe.db.char.uptime.sl

    ShockAndAwe.uptime.session.buffs[GetSpellInfo(ShockAndAwe.constants["Stormlash ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    ShockAndAwe.uptime.lastfight.buffs[GetSpellInfo(ShockAndAwe.constants["Stormlash ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end
  --
  function ShockAndAwe:getSBColor(info)
    local colors = ShockAndAwe.db.char.uptime.sb
    return colors.r, colors.g, colors.b, colors.a
  end
  --
  function ShockAndAwe:setSBColor(info,r,g,b,a)
    ShockAndAwe.db.char.uptime.sb.r = r
    ShockAndAwe.db.char.uptime.sb.g = g
    ShockAndAwe.db.char.uptime.sb.b = b
    ShockAndAwe.db.char.uptime.sb.a = a
    local buffColors = ShockAndAwe.db.char.uptime.sb

    ShockAndAwe.uptime.session.buffs[GetSpellInfo(ShockAndAwe.constants["Shield Block ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
    ShockAndAwe.uptime.lastfight.buffs[GetSpellInfo(ShockAndAwe.constants["Shield Block ID"])].barFrame.statusbar:SetStatusBarColor(buffColors.r, buffColors.g, buffColors.b, buffColors.a)
  end

  function ShockAndAwe:getWFTotalsColor(info)
    local colors = ShockAndAwe.db.char.stats.wfcol
    return colors.r, colors.g, colors.b, colors.a
  end

  function ShockAndAwe:setWFTotalsColor(info,r,g,b,a)
    ShockAndAwe.db.char.stats.wfcol.r = r
    ShockAndAwe.db.char.stats.wfcol.g = g
    ShockAndAwe.db.char.stats.wfcol.b = b
    ShockAndAwe.db.char.stats.wfcol.a = a
  end

  function ShockAndAwe:getFrameStrataLevel(info)
    local retValue = ShockAndAwe.db.char.framestratalevel

    if retValue == "BACKGROUND" then
      return 1
    elseif retValue == "LOW" then
      return 2
    elseif retValue == "MEDIUM" then
      return 3
    else
      return 4
    end
  end

  function ShockAndAwe:setFrameStrataLevel(info, newValue)
    if newValue == 1 then
      newValue = "BACKGROUND"
    elseif newValue == 2 then
      newValue = "LOW"
    elseif newValue == 3 then
      newValue = "MEDIUM"
    else
      newValue = "HIGH"
    end
    ShockAndAwe.db.char.framestratalevel = newValue
    ShockAndAwe:RedrawFrames()
    ShockAndAwe:Print(L["config_framestratalevel"]..newValue)
  end
  -----------------------------------------
  -- Annoucement Functions
  -----------------------------------------
  function ShockAndAwe:MessageType(input)
    i = { "SAY", "YELL", "PARTY", "RAID" }
    return i[input]
  end

  --Skull Banner
  function ShockAndAwe:SkullBannerAnnounceQuery()
    -- return ShockAndAwe.db.char.announce_skull_banner
  end

  function ShockAndAwe:ActivateAnnounceSkullBanner()
    -- ShockAndAwe.db.char.announce_skull_banner = not ShockAndAwe.db.char.announce_skull_banner
    -- if (ShockAndAwe.db.char.announce_skull_banner) then
    -- ShockAndAwe:Print(L["config_skull_banner_announce_on"])
    -- else
    -- ShockAndAwe:Print(L["config_skull_banner_announce_off"])
    -- end
  end

  function ShockAndAwe:GetSkullBannerAnnounceLocation(info)
    -- return ShockAndAwe.db.char.announce_skull_banner_where
  end

  function ShockAndAwe:SetSkullBannerAnnounceLocation(info, newValue)
    -- ShockAndAwe.db.char.announce_skull_banner_where = newValue
    -- ShockAndAwe:Print(L["config_skull_banner_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  --Demoralizing Banner
  function ShockAndAwe:DemoralizingBannerAnnounceQuery()
    -- return ShockAndAwe.db.char.announce_demoralizing_banner
  end

  function ShockAndAwe:ActivateAnnounceDemoralizingBanner()
    -- ShockAndAwe.db.char.announce_demoralizing_banner = not ShockAndAwe.db.char.announce_demoralizing_banner
    -- if (ShockAndAwe.db.char.announce_demoralizing_banner) then
    -- ShockAndAwe:Print(L["config_demoralizing_banner_announce_on"])
    -- else
    -- ShockAndAwe:Print(L["config_demoralizing_banner_announce_off"])
    -- end
  end

  function ShockAndAwe:GetDemoralizingBannerAnnounceLocation(info)
    -- return ShockAndAwe.db.char.announce_demoralizing_banner_where
  end

  function ShockAndAwe:SetDemoralizingBannerAnnounceLocation(info, newValue)
    -- ShockAndAwe.db.char.announce_demoralizing_banner_where = newValue
    -- ShockAndAwe:Print(L["config_demoralizing_banner_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  --Mocking Banner
  function ShockAndAwe:MockingBannerAnnounceQuery()
    -- return ShockAndAwe.db.char.announce_mocking_banner
  end

  function ShockAndAwe:ActivateAnnounceMockingBanner()
    -- ShockAndAwe.db.char.announce_mocking_banner = not ShockAndAwe.db.char.announce_mocking_banner
    -- if (ShockAndAwe.db.char.announce_mocking_banner) then
    -- ShockAndAwe:Print(L["config_mocking_banner_announce_on"])
    -- else
    -- ShockAndAwe:Print(L["config_mocking_banner_announce_off"])
    -- end
  end

  function ShockAndAwe:GetMockingBannerAnnounceLocation(info)
    -- return ShockAndAwe.db.char.announce_mocking_banner_where
  end

  function ShockAndAwe:SetMockingBannerAnnounceLocation(info, newValue)
    -- ShockAndAwe.db.char.announce_mocking_banner_where = newValue
    -- ShockAndAwe:Print(L["config_mocking_banner_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  --Interrupt Announce
  function ShockAndAwe:InterruptAnnounceQuery()
    return ShockAndAwe.db.char.announce_interrupt
  end

  function ShockAndAwe:ActivateAnnounceInterrupt()
    ShockAndAwe.db.char.announce_interrupt = not ShockAndAwe.db.char.announce_interrupt
    if (ShockAndAwe.db.char.announce_interrupt) then
      ShockAndAwe:Print(L["config_interrupt_announce_on"])
    else
      ShockAndAwe:Print(L["config_interrupt_announce_off"])
    end
  end

  function ShockAndAwe:LastStandAnnounceQuery()
    return ShockAndAwe.db.char.announce_laststand
  end

  function ShockAndAwe:ActivateAnnounceLastStand()
    ShockAndAwe.db.char.announce_laststand = not ShockAndAwe.db.char.announce_laststand
    if (ShockAndAwe.db.char.announce_laststand) then
      ShockAndAwe:Print(L["config_laststand_announce_on"])
    else
      ShockAndAwe:Print(L["config_laststand_announce_off"])
    end
  end

  function ShockAndAwe:ShieldWallAnnounceQuery()
    return ShockAndAwe.db.char.announce_shieldwall
  end

  function ShockAndAwe:ActivateAnnounceShieldWall()
    ShockAndAwe.db.char.announce_shieldwall = not ShockAndAwe.db.char.announce_shieldwall
    if (ShockAndAwe.db.char.announce_shieldwall) then
      ShockAndAwe:Print(L["config_shieldwall_announce_on"])
    else
      ShockAndAwe:Print(L["config_shieldwall_announce_off"])
    end
  end

  function ShockAndAwe:GetInterruptAnnounceLocation(info)
    return ShockAndAwe.db.char.announce_interrupt_where
  end

  function ShockAndAwe:SetInterruptAnnounceLocation(info, newValue)
    ShockAndAwe.db.char.announce_interrupt_where = newValue
    ShockAndAwe:Print(L["config_interrupt_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  function ShockAndAwe:GetLastStandAnnounceLocation(info)
    return ShockAndAwe.db.char.announce_laststand_where
  end

  function ShockAndAwe:SetLastStandAnnounceLocation(info, newValue)
    ShockAndAwe.db.char.announce_laststand_where = newValue
    ShockAndAwe:Print(L["config_laststand_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  function ShockAndAwe:GetShieldWallAnnounceLocation(info)
    return ShockAndAwe.db.char.announce_shieldwall_where
  end

  function ShockAndAwe:SetShieldWallAnnounceLocation(info, newValue)
    ShockAndAwe.db.char.announce_shieldwall_where = newValue
    ShockAndAwe:Print(L["config_shieldwall_announce_where"]..ShockAndAwe:MessageType(newValue))
  end

  -----------------------------------------
  -- Priority Choices
  -----------------------------------------

  function ShockAndAwe:GetPriorityGroup(info)
    return ShockAndAwe.db.char.priority.groupnumber
  end

  function ShockAndAwe:SetPriorityGroup(info, groupnumber)
    ShockAndAwe.db.char.priority.groupnumber = groupnumber
    ShockAndAwe:SelectPrioritySet(groupnumber)
  end

  function ShockAndAwe:GetPriority(index)
    return
    function(info)
      return ShockAndAwe.db.char.priority.prOption[index]
    end
  end

  function ShockAndAwe:SetPriority(index)
    return
    function(info, priorityValue)
      ShockAndAwe:DebugPrint("Setting priority "..index.." to "..priorityValue)
      ShockAndAwe.db.char.priority.prOption[index] = priorityValue
      ShockAndAwe.db.char.priority.prOptions[ShockAndAwe.db.char.priority.groupnumber] = ShockAndAwe.db.char.priority.prOption
    end
  end

  function ShockAndAwe:priorityQuery()
    return ShockAndAwe.db.char.priority.show
  end

  function ShockAndAwe:ActivatePriority()
    ShockAndAwe.db.char.priority.show = not ShockAndAwe.db.char.priority.show
    if (ShockAndAwe.db.char.priority.show) then
      ShockAndAwe:Print(L["config_priority_on"])
    else
      ShockAndAwe.PriorityFrame:Hide()
      ShockAndAwe:Print(L["config_priority_off"])
    end
  end

  function ShockAndAwe:priorityTitleQuery()
    return ShockAndAwe.db.char.priority.titleshow
  end

  function ShockAndAwe:ActivatePriorityTitle()
    ShockAndAwe.db.char.priority.titleshow = not ShockAndAwe.db.char.priority.titleshow
    if ShockAndAwe.db.char.priority.titleshow then
      ShockAndAwe.PriorityFrame.topText:Show()
      ShockAndAwe:Print(L["config_prioritytitle_on"])
    else
      ShockAndAwe.PriorityFrame.topText:Hide()
      ShockAndAwe:Print(L["config_prioritytitle_off"])
    end
  end

  ---------------
  -- Warnings
  ---------------

  function ShockAndAwe:WarningFrameQuery()
    return ShockAndAwe.db.char.warning.show
  end

  function ShockAndAwe:ActivateWarningFrame()
    ShockAndAwe.db.char.warning.show = not ShockAndAwe.db.char.warning.show
    if (ShockAndAwe.db.char.warning.show) then
      ShockAndAwe:Print(L["config_warnframe_on"])
    else
      ShockAndAwe:Print(L["config_warnframe_off"])
    end
  end

  function ShockAndAwe:rangeWarnQuery()
    return ShockAndAwe.db.char.warning.range
  end

  function ShockAndAwe:ActivateRangeWarn()
    ShockAndAwe.db.char.warning.range = not ShockAndAwe.db.char.warning.range
    if (ShockAndAwe.db.char.warning.range) then
      ShockAndAwe:Print(L["config_rangewarn_on"])
    else
      ShockAndAwe:Print(L["config_rangewarn_off"])
    end
  end

  function ShockAndAwe:interruptWarnQuery()
    return ShockAndAwe.db.char.warning.interrupt
  end

  function ShockAndAwe:enableDisableBorderQuery()
    return ShockAndAwe.db.char.enableDisableBorder
  end

  function ShockAndAwe:enableDisableMaelstromBarBorderQuery()
    return ShockAndAwe.db.char.maelstrombar.enableDisableBorder
  end

  function ShockAndAwe:enableDisablePriorityBorderQuery()
    return ShockAndAwe.db.char.priority.enableDisableBorder
  end

  function ShockAndAwe:ActivateEnableDisableBorder()
    ShockAndAwe.db.char.enableDisableBorder = not ShockAndAwe.db.char.enableDisableBorder
    if (ShockAndAwe.db.char.enableDisableBorder) then
      ShockAndAwe:Print("Borders will no longer be shown")
      ShockAndAwe.barBackdrop = {
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      }
      ShockAndAwe.frameBackdrop ={
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      }
      ShockAndAwe.frames["GCD"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["IgnorePain"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldBlock"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldWall"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ColossusSmash"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["BattleCry"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Bloodbath"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Avatar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DragonRoar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DemoShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["LastStand"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["CommandingShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["GCD"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["IgnorePain"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ShieldBlock"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ShieldWall"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ColossusSmash"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["BattleCry"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["Bloodbath"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["Avatar"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["DragonRoar"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["DemoShout"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["LastStand"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["CommandingShout"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe:RedrawFrames()
    else
      ShockAndAwe.barBackdrop = {
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = false, tileSize = 0, edgeSize = 12,
        insets = { left = 2, right = 2, top = 2, bottom = 2 }
      }
      ShockAndAwe.frameBackdrop ={
        bgFile = "Interface/Tooltips/UI-Tooltip-Background",
        --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
        tile = false, tileSize = 0, edgeSize = 12,
        insets = { left = 0, right = 0, top = 0, bottom = 0 }
      }

      ShockAndAwe.frames["GCD"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["IgnorePain"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldBlock"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ShieldWall"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["ColossusSmash"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["BattleCry"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Bloodbath"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["Avatar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DragonRoar"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["DemoShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["LastStand"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["CommandingShout"]:SetBackdrop(ShockAndAwe.barBackdrop)
      ShockAndAwe.frames["GCD"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["IgnorePain"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ShieldBlock"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ShieldWall"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["ColossusSmash"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["BattleCry"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["Bloodbath"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["Avatar"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["DragonRoar"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["DemoShout"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["LastStand"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe.frames["CommandingShout"]:SetBackdrop(ShockAndAwe.frameBackdrop)
      ShockAndAwe:RedrawFrames()
    end
  end

  function ShockAndAwe:ActivateEnableDisablePriorityBorder()
    ShockAndAwe.db.char.priority.enableDisableBorder = not ShockAndAwe.db.char.priority.enableDisableBorder

    if (ShockAndAwe.db.char.priority.enableDisableBorder) then
      ShockAndAwe:Print("Priority border will no longer be shown")
      --[[ ShockAndAwe.priorityBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    ShockAndAwe.priorityframeBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    -- ShockAndAwe.PriorityFrame:SetBackdrop(ShockAndAwe.prioritybarBackdrop)
    -- ShockAndAwe.PriorityFrame:SetBackdrop(ShockAndAwe.priorityframeBackdrop)
    ]]
    ShockAndAwe:RedrawFrames()
  else
    --[[
    ShockAndAwe.priorityBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }

    ShockAndAwe.priorityframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }

    -- ShockAndAwe.PriorityFrame:SetBackdrop(ShockAndAwe.priorityBackdrop)
    -- ShockAndAwe.PriorityFrame:SetBackdrop(ShockAndAwe.priorityframeBackdrop)
    ]]
    ShockAndAwe:RedrawFrames()
  end
end

function ShockAndAwe:ActivateEnableDisableMaelstromBarBorder()
  ShockAndAwe.db.char.maelstrombar.enableDisableBorder = not ShockAndAwe.db.char.maelstrombar.enableDisableBorder
  if (ShockAndAwe.db.char.maelstrombar.enableDisableBorder) then
    ShockAndAwe:Print("Borders will no longer be shown")
    ShockAndAwe.maelstrombarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    ShockAndAwe.maelstromframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
    }
    ShockAndAwe.frames["Maelstrom"]:SetBackdrop(ShockAndAwe.maelstrombarBackdrop)
    ShockAndAwe.frames["Maelstrom"]:SetBackdrop(ShockAndAwe.maelstromframeBackdrop)
    ShockAndAwe:RedrawFrames()
  else

    ShockAndAwe.maelstrombarBackdrop = {
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 2, right = 2, top = 2, bottom = 2 }
    }

    ShockAndAwe.maelstromframeBackdrop ={
      bgFile = "Interface/Tooltips/UI-Tooltip-Background",
      --edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
      tile = false, tileSize = 0, edgeSize = 12,
      insets = { left = 0, right = 0, top = 0, bottom = 0 }
    }

    ShockAndAwe.frames["Maelstrom"]:SetBackdrop(ShockAndAwe.maelstrombarBackdrop)
    ShockAndAwe.frames["Maelstrom"]:SetBackdrop(ShockAndAwe.maelstromframeBackdrop)
    ShockAndAwe:RedrawFrames()
  end

  ShockAndAwe:MaelstromBar()
end

function ShockAndAwe:ActivateInterruptWarn()
  ShockAndAwe.db.char.warning.interrupt = not ShockAndAwe.db.char.warning.interrupt
  if (ShockAndAwe.db.char.warning.interrupt) then
    ShockAndAwe:Print(L["config_interruptwarn_on"])
  else
    ShockAndAwe:Print(L["config_interruptwarn_off"])
  end
end

function ShockAndAwe:EnableDisable()
  if ShockAndAwe.db.char.disabled then
    ShockAndAwe:Enable()
  else
    ShockAndAwe:Disable()
  end
end

function ShockAndAwe:Disable()
  if InCombatLockdown() then
    ShockAndAwe:Print(L["Cannot enable/disable addon in combat"])
    return
  end
  ShockAndAwe.db.char.disabled = true
  ShockAndAwe:OnDisable()
  ShockAndAwe.PriorityFrame:Hide()
  ShockAndAwe.UptimeFrame:Hide()
  ShockAndAwe.frames["Maelstrom"]:Hide()
  ShockAndAwe.frames["IgnorePain"]:Hide()
  ShockAndAwe.frames["IgnorePain"].icon:Hide()
  ShockAndAwe:Print(L["config_disabled_on"])
end

function ShockAndAwe:Enable()

  local currentSpec = GetSpecialization()
  if InCombatLockdown() then
    ShockAndAwe:Print(L["Cannot enable/disable addon in combat"])
    return
  end
  ShockAndAwe.db.char.disabled = false
  ShockAndAwe:OnEnable()
  ShockAndAwe:RedrawFrames()
  if not ShockAndAwe.db.char.movingframes then -- need to ensure moving frames is false on enabled to disabled to enabled
    ShockAndAwe.db.char.movingframes = true -- forces false in ShowHideBars to re-enable frames -- need a better hack
  else
    ShockAndAwe.db.char.movingframes = false
  end

  ShockAndAwe:ShowHideBars()
  ShockAndAwe:Print(L["config_disabled_off"])
  ShockAndAwe:MaelstromBar()

end

function ShockAndAwe:ResetImmunity()
  ShockAndAwe.db.char.immuneTargets = {}
  ShockAndAwe:Print(L["config_resetImmunity"])
end

function ShockAndAwe:GetMSBTareas(info)
  return ShockAndAwe.db.char.MSBToutputarea
end

function ShockAndAwe:SetMSBTareas(info, value)
  ShockAndAwe.db.char.MSBToutputarea = value
end

function ShockAndAwe:getWarningColor(info)
  local colors = ShockAndAwe.db.char.warning.color
  return colors.r, colors.g, colors.b, colors.a
end

function ShockAndAwe:setWarningColor(info,r,g,b,a)
  ShockAndAwe.db.char.warning.color.r = r
  ShockAndAwe.db.char.warning.color.g = g
  ShockAndAwe.db.char.warning.color.b = b
  ShockAndAwe.db.char.warning.color.a = a
end

function ShockAndAwe:GetWarningDuration(info)
  return ShockAndAwe.db.char.warning.duration
end

function ShockAndAwe:SetWarningDuration(info, priorityValue)
  ShockAndAwe.db.char.warning.duration = priorityValue
end

function ShockAndAwe:OpenConfig()
  if InterfaceOptionsFrame_OpenToCategory then
    InterfaceOptionsFrame_OpenToCategory("ShockAndAwe");
  else
    InterfaceOptionsFrame_OpenToFrame("ShockAndAwe");
  end
end

function ShockAndAwe:GetMSBTAreaDefaults()
  local i = 0;
  ShockAndAwe.MSBT = {}
  ShockAndAwe.MSBT.areas = {}
  if MikSBT ~= nil and MikSBT.IterateScrollAreas ~= nil then
    for scrollAreaKey, scrollAreaName in MikSBT.IterateScrollAreas() do
      i = i + 1
      ShockAndAwe.MSBT.areas[i] = scrollAreaName
    end
  end
end

function ShockAndAwe:DebugPrintPriorityGroups ()
  for group = 1, 5 do
    for index = 1, 30 do
      print("ShockAndAwe.furyOptions = { \""..ShockAndAwe.db.char.priority.prOptions[group][index].."\"")
    end
  end
end
